/**
 * Custom jQuery for Custom Metaboxes and Fields
 */
jQuery(document).ready( function($) {
        
        /**
         * Init tabs
         */
        if (jQuery.fn.tabs) {
                jQuery( "#tabs" ).tabs(); 
        }
        
        /**
         * Init color picker
         */
        jQuery('.colorpicker').wpColorPicker();
        
        /**
         * Hide / show elements
         */
        jQuery('.select-change').change(function() {
                var self = jQuery(this),
                    id = self.attr('id');
                
                if ( self.attr('type') == 'checkbox' ) {
                        var value = self.is(':checked') ? '1' : '0';
                } else {
                        var value = self.val();
                }
                
                jQuery('*[data-check-field*="' + id + '"]').hide();

                if ( value.length > 0 ) {
                        jQuery('*[data-check-value*="' + id + '-' + value + '"]').show();  
                }
        });
        
        jQuery('#live_style_masonry, #live_style_list').change(function() {  
                if( jQuery(this).val() == 'masonry' ) {
                        jQuery('#display_thumbnail').attr('checked','checked').prop('disabled',true);
                        jQuery('#display_thumbnail_hidden').val('1');
                } else {
                        jQuery('#display_thumbnail').prop('disabled',false);
                }
        });
        
        /**
         * Open media uploader
         */
        jQuery('.uploader').on('click', '.upload_image_button', function(e) {
                e.preventDefault();
                
                var button = jQuery(this);

                var custom_uploader = wp.media({
                        title: cmb_vars.mediaTitle,
                        button: {
                                text: cmb_vars.mediaButton
                        },
                        library: {
                                type: 'image'
                        },
                        frame: 'select',
                        multiple: false  // Set this to true to allow multiple files to be selected
                }).on('select', function() {
                        var selections = custom_uploader.state().get('selection');
                        selections.each(function(selection) {
                                attachment = selection.toJSON();
                                
                                var size = (typeof (attachment.sizes["thumbnail"]) == 'undefined') ? attachment : attachment.sizes["thumbnail"],
                                    btn_parent = button.parent().parent().parent();

                                btn_parent.find(".image-preview").append('<li id="loading_gif_preview">'
                                                         + '<img src="' + size.url +'">'
                                                         + '<a href="javascript:;" id="delete_loading_gif" class="cmb-button small-button delete-media">&times;</a>'
                                                         + '</li>');
                                jQuery('#loading_gif').val(attachment.id);
                                button.parent().hide();
                        });
                })
                .open();
        });
        
        jQuery('#display_thumbnail').change( function() {
                var value = jQuery(this).is(':checked') ? '1' : '0';
                jQuery('#display_thumbnail_hidden').val( value );     
        });
        
        /**
         * Delete media
         */
        jQuery('.image-preview').on('click', '#delete_loading_gif', function() {
                (jQuery(this).parent().parent().parent()).find('.uploader').show();
                jQuery('#loading_gif_preview').remove();
                jQuery('#loading_gif').val('');
        });
        
        /**
         * Index ajax action
         */
        jQuery('#searchford_index_ajax').click(function() {
                var nonce = jQuery('#searchford_create_index_nonce_field').val(),
                    self = jQuery(this),
                    $result = jQuery('#searchford_index_ajax_result'),
                    $load = jQuery('.searchford-loading');
                
                self.prop('disabled', true);
                $result.remove();
                $load.addClass('loading');
                
                jQuery.ajax({
                        type : "post",
                        url : ajaxurl,
                        dataType: 'json',
                        data : {
                                nonce: nonce,
                                action: 'searchford_index'
                        },
                        success: function(response) {
                                $('div.wrap h2:first').after('<div id="searchford_index_ajax_result" class="updated"><p><strong>' + response['success'] + '</strong></p></div>');
                                $load.removeClass('loading');
                                self.prop('disabled',false);
                                
                                for( var i = 0; i < 5; i++ ) {
                                        jQuery('#max' + i).html(response.max[i].max);
                                }
                        },
                        error: function(error) {
                                $('div.wrap h2:first').after('<div id="searchford_index_ajax_result" class="error"><p><strong>' + error + '</strong></p></div>');
                                $load.removeClass('loading');
                                self.prop('disabled',false);
                        }
                });
        });
        
        /**
         * Add Custom Taxonomy Row
         */
        jQuery('#add_taxonomy').click( function(e) {
                e.preventDefault();
                
                var parent = jQuery(this).parent().parent();

                parent.find('div.js-hide:first').removeClass('js-hide').show();
                
        });
        
        /**
         * Hide Custom Taxonomy Row
         */
        jQuery('.hide-taxonomy').click( function(e) {
                e.preventDefault();
                
                var id = ( jQuery(this).attr('id') ).replace('hide_taxonomy', '');
                
                jQuery('#exclude_taxonomy' + id).val('');
                jQuery('#exclude_taxonomy_slug' + id).val('');
                jQuery('#taxonomy' + id).find('.taxonomy-link').hide();
                jQuery('#taxonomy' + id).addClass('js-hide').hide();
        });
        
        /**
         * Show Custom Taxonomy List
         */
        jQuery('.exclude-taxonomy').change( function() {
                
                var self = jQuery(this),
                    selected = self.val(),
                    $link = self.parent().parent().find('.taxonomy-link');
                
                if( selected != '' ) {
                        $link.show();
                        $link.find('a').attr('href','edit-tags.php?taxonomy=' + selected);
                } else {
                        $link.hide();
                }
        });
        
        jQuery('.js-hide').hide();
});
