<?php
$tabs = array(
        'general' => __('General Settings', SEARCHFORD_SLUG),
        'live' => __('Live Search', SEARCHFORD_SLUG),
        'index' => __('Search Index', SEARCHFORD_SLUG),
        );
?>
<div class="wrap searchford-admin">
        <h2><?php echo SEARCHFORD_NAME; ?></h2>
        <div id="tabs" class="clearfix">
                <ul>
                <?php foreach ( $tabs as $k => $label): ?>
                        <li><a href="#tabs-<?php echo $k; ?>"><?php echo $label; ?></a></li>
                <?php endforeach; ?>
                </ul>
                <form method="post" action="options.php">
                        <?php settings_fields( SEARCHFORD_OPTIONS . '_group' ); ?>
                        <div id="tabs-general">
                                <h4 class="description"><?php _e('These settings applies to the default search form and search plugin.', SEARCHFORD_SLUG); ?></h4>
                                <table class="form-table">
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Sort Results By', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <label for="sort_relevance"><input type="radio" id="sort_relevance" name="<?php echo SEARCHFORD_OPTIONS; ?>[sort]" value="relevance" <?php checked($sort, 'relevance'); ?> /><?php _e('Relevance', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="sort_date"><input type="radio" id="sort_date" name="<?php echo SEARCHFORD_OPTIONS; ?>[sort]" value="date" <?php checked($sort, 'date'); ?> /><?php _e('Date', SEARCHFORD_SLUG); ?></label>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Search Term In', SEARCHFORD_SLUG); ?></th>
                                                <td colspan="2">
                                                        <p>
                                                                <label for="search_title"><input type="checkbox" class="select-change" id="search_title" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="title" <?php if( in_array('title', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Title', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="search_content"><input type="checkbox" class="select-change" id="search_content" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="content" <?php if( in_array('content', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Content', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="search_category"><input type="checkbox" class="select-change" id="search_category" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="category" <?php if( in_array('category', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Categories', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="search_tag"><input type="checkbox"  class="select-change" id="search_tag" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="post_tag" <?php if( in_array('post_tag', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Tags', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="search_comment"><input type="checkbox" class="select-change"id="search_comment" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="comment" <?php if( in_array('comment', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Comments', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="search_media"><input type="checkbox" class="select-change"id="search_media" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="attachment" <?php if( in_array('attachment', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Attachments', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="search_author"><input type="checkbox" class="select-change"id="search_author" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="author" <?php if( in_array('author', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Author (Display name, first name, last name and description)', SEARCHFORD_SLUG); ?></label><br />
                                                                <div class="<?php if( !in_array('author', $search_in) ) echo ' js-hide'; ?>" data-check-field="search_author" data-check-value="search_author-1">
                                                                <?php foreach( $wp_roles as $r => $r_arr ): ?>
                                                                        <div class="row collapse">
                                                                                <div class="small-1 columns"></div>
                                                                                <div class="small-10 columns end">     
                                                                                        <label for="roles_<?php echo $r; ?>"><input type="checkbox" id="roles_<?php echo $r; ?>" name="<?php echo SEARCHFORD_OPTIONS; ?>[roles][]" value="<?php echo $r; ?>" <?php if( in_array($r, $roles) ) echo 'checked="checked"'; ?> /><?php echo $r_arr['name']; ?></label>
                                                                                </div>
                                                                        </div>
                                                                <?php endforeach; ?>
                                                                </div>
                                                                <label for="search_custom_taxonomy"><input type="checkbox" class="select-change" id="search_custom_taxonomy" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="taxonomy" <?php if( in_array('taxonomy', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Custom Taxonomy', SEARCHFORD_SLUG); ?></label><br />
                                                                <div class="<?php if( !in_array('taxonomy', $search_in) ) echo ' js-hide'; ?>" data-check-field="search_custom_taxonomy" data-check-value="search_custom_taxonomy-1">
                                                                <?php foreach( $taxonomies as $t ): ?>
                                                                        <div class="row collapse">
                                                                                <div class="small-1 columns"></div>
                                                                                <div class="small-10 columns end">     
                                                                                        <label for="custom_taxonomy_<?php echo $t; ?>"><input type="checkbox" id="custom_taxonomy_<?php echo $t; ?>" name="<?php echo SEARCHFORD_OPTIONS; ?>[custom_taxonomy][]" value="<?php echo $t; ?>" <?php if( in_array($t, $custom_taxonomy) ) echo 'checked="checked"'; ?> /><?php echo $t; ?></label>
                                                                                </div>
                                                                        </div>
                                                                <?php endforeach; ?>
                                                                </div>
                                                                <label for="search_custom_meta"><input type="checkbox" class="select-change" id="search_custom_meta" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_in][]" value="meta" <?php if( in_array('meta', $search_in) ) echo 'checked="checked"'; ?> /><?php _e('Custom Meta Field', SEARCHFORD_SLUG); ?></label><br />
                                                                <div class="row collapse<?php if( !in_array('meta', $search_in) ) echo ' js-hide'; ?>" data-check-field="search_custom_meta" data-check-value="search_custom_meta-1">
                                                                        <div class="small-1 columns"></div>
                                                                        <div class="small-10 columns end">     
                                                                                <input type="text" id="custom_meta" class="regular-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[custom_meta]" value="<?php echo esc_html( $custom_meta ); ?>" /><span class="description"><?php _e('Enter custom meta keys separated by commas. Database will be re-indexed automatically after saving.'); ?></span>
                                                                        </div>
                                                                </div>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Show Results From The Following Post Types', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <div class="margin30">
                                                                <div class="row collapse">
                                                                        <div class="small-2 columns">
                                                                                <strong><?php _e('Name', SEARCHFORD_SLUG); ?></strong>
                                                                        </div>
                                                                        <div class="small-10 end columns">
                                                                                <strong><?php _e('Slug', SEARCHFORD_SLUG); ?></strong>
                                                                        </div>
                                                                </div>
                                                                <?php foreach( $post_types as $type => $obj): ?>
                                                                        <?php if( $obj->public != true && !in_array($type, $include) ): ?>
                                                                        <div class="row collapse<?php if ( $non_public != '1' ) echo ' js-hide'; ?>" data-check-field="non_public" data-check-value="non_public-1">
                                                                                <div class="small-2 columns">
                                                                                        <label for="include_<?php echo $type; ?>"><input type="checkbox" id="include_<?php echo $type; ?>" name="<?php echo SEARCHFORD_OPTIONS; ?>[include][]" value="<?php echo $type; ?>" <?php if( in_array($type, $include) ) echo 'checked="checked"'; ?> /><?php echo $obj->labels->name; ?></label>
                                                                                </div>
                                                                                <div class="small-10 end columns">
                                                                                        <?php echo $type; ?>
                                                                                </div>
                                                                        </div>
                                                                        <?php else: ?>
                                                                        <div class="row collapse">
                                                                                <div class="small-2 columns">
                                                                                        <label for="include_<?php echo $type; ?>"><input type="checkbox" id="include_<?php echo $type; ?>" name="<?php echo SEARCHFORD_OPTIONS; ?>[include][]" value="<?php echo $type; ?>" <?php if( in_array($type, $include) ) echo 'checked="checked"'; ?> /><?php echo $obj->labels->name; ?></label>
                                                                                </div>
                                                                                <div class="small-10 end columns">
                                                                                        <?php echo $type; ?>
                                                                                </div>
                                                                        </div>
                                                                        <?php endif; ?>
                                                                <?php endforeach; ?>
                                                        </div>
                                                        <label for="non_public"><input class="select-change" type="checkbox" id="non_public" name="<?php echo SEARCHFORD_OPTIONS; ?>[non_public]" value="1" <?php checked($non_public, '1'); ?> /><?php _e('Show non-public post types', SEARCHFORD_SLUG); ?></label>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Enable Fuzzy Search', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <p>
                                                                <input type="hidden" id="fuzzy_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[fuzzy]" value="0" />
                                                                <label for="fuzzy"><input type="checkbox" id="fuzzy" name="<?php echo SEARCHFORD_OPTIONS; ?>[fuzzy]" value="1" <?php checked($fuzzy, '1'); ?> /><?php _e('Automatically search for word endings and wildcard characters if no other search operators are detected.', SEARCHFORD_SLUG); ?></label>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Highlight Search Terms', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <p>
                                                                <input type="hidden" id="highlight_title_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_title]" value="0" />
                                                                <input type="hidden" id="highlight_excerpt_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_excerpt]" value="0" />
                                                                <input type="hidden" id="highlight_author_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_author]" value="0" />
                                                                <input type="hidden" id="highlight_tags_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_tags]" value="0" />
                                                                <div<?php if( !in_array('title', $search_in) ) echo ' class="js-hide"'; ?> data-check-field="search_title" data-check-value="search_title-1">
                                                                        <label for="highlight_title"><input type="checkbox" id="highlight_title" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_title]" value="1" <?php checked($highlight_title, '1'); ?> /><?php _e('In Title', SEARCHFORD_SLUG); ?></label>
                                                                </div>
                                                                <div<?php if( !in_array('content', $search_in) ) echo ' class="js-hide"'; ?> data-check-field="search_content" data-check-value="search_title-1">
                                                                        <label for="highlight_excerpt"><input type="checkbox" id="highlight_excerpt" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_excerpt]" value="1" <?php checked($highlight_excerpt, '1'); ?> /><?php _e('In Excerpt (Where applicable)', SEARCHFORD_SLUG); ?></label><br />
                                                                </div>
                                                                <div<?php if( !in_array('author', $search_in) ) echo ' class="js-hide"'; ?> data-check-field="search_author" data-check-value="search_author-1">
                                                                        <label for="highlight_author"><input type="checkbox" id="highlight_author" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_author]" value="1" <?php checked($highlight_author, '1'); ?> /><?php _e('In Author', SEARCHFORD_SLUG); ?></label><br />
                                                                </div>
                                                                <label for="highlight_tags"><input type="checkbox" id="highlight_tags" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_tags]" value="1" <?php checked($highlight_tags, '1'); ?> /><?php _e('In Tags, Categories and Taxonomies (Where applicable)', SEARCHFORD_SLUG); ?></label>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Highlight Style', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <p>
                                                                <label for="highlight_bold"><input type="radio" id="highlight_bold" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_style]" value="bold" <?php checked($highlight_style, 'bold'); ?> /><?php _e('Bold', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="highlight_italics"><input type="radio" id="highlight_italics" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_style]" value="italics" <?php checked($highlight_style, 'italics'); ?> /><?php _e('Italics', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="highlight_underline"><input type="radio" id="highlight_underline" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_style]" value="underline" <?php checked($highlight_style, 'underline'); ?> /><?php _e('Underline', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="highlight_color"><input type="radio" id="highlight_color" class="select-change" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_style]" value="color" <?php checked($highlight_style, 'color'); ?> /><?php _e('Color', SEARCHFORD_SLUG); ?></label><br />
                                                                <div class="<?php if( $highlight_style != 'color' ) echo ' js-hide'; ?>" data-check-field="highlight_color" data-check-value="highlight_color-color">
                                                                        <div class="row collapse">
                                                                                <div class="small-1 columns"></div>
                                                                                <div class="small-1 columns">     
                                                                                        <?php _e('Font Color', SEARCHFORD_SLUG); ?>
                                                                                </div>
                                                                                <div class="small-10 columns end">     
                                                                                        <input type="text" id="highlight_text_color" class="colorpicker" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_text_color]" value="<?php echo $highlight_text_color; ?>" />
                                                                                </div>
                                                                        </div>
                                                                        <div class="row collapse">
                                                                                <div class="small-1 columns"></div>
                                                                                <div class="small-1 columns">     
                                                                                        <?php _e('Background Color', SEARCHFORD_SLUG); ?>
                                                                                </div>
                                                                                <div class="small-10 columns end">     
                                                                                        <input type="text" id="highlight_background_color" class="colorpicker" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_background_color]" value="<?php echo $highlight_background_color; ?>" />
                                                                                </div>
                                                                        </div>
                                                                </div>
                                                                <label for="highlight_css"><input type="radio" id="highlight_css" class="select-change" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_style]" value="css" <?php checked($highlight_style, 'css'); ?> /><?php _e('Style', SEARCHFORD_SLUG); ?></label><br />
                                                                <div class="<?php if( $highlight_style != 'css' ) echo ' js-hide'; ?>" data-check-field="highlight_css" data-check-value="highlight_css-css">
                                                                        <div class="row collapse">
                                                                                <div class="small-1 columns"></div>
                                                                                <div class="small-10 columns">     
                                                                                        &lt;span style="<input type="text" id="highlight_background_color" name="<?php echo SEARCHFORD_OPTIONS; ?>[highlight_background_color]" value="<?php echo $highlight_background_color; ?>" />"&gt;<em>Search Term</em>&lt;&#47;span&gt
                                                                                </div>
                                                                        </div>
                                                                </div>
                                                                
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Weights', SEARCHFORD_SLUG); ?>
                                                        <p class="description"><?php _e('Search terms found in types with heavier weights will be sorted higher for relevance.', SEARCHFORD_SLUG); ?></p>
                                                </th>
                                                <td valign="top">
                                                        <div class="row collapse">
                                                                <div class="small-2 columns">
                                                                        <strong><?php _e('Type', SEARCHFORD_SLUG); ?></strong>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <strong><?php _e('Weight', SEARCHFORD_SLUG); ?></strong>
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'title', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_title" data-check-value="search_title-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Title', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[title_weight]" id="title_weight" value="<?php echo (float) $title_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'content', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_content" data-check-value="search_content-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Content', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[content_weight]" id="content_weight" value="<?php echo (float) $content_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'category', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_category" data-check-value="search_category-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Categories', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[category_weight]" id="category_weight" value="<?php echo (float) $category_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'post_tag', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_tag" data-check-value="search_tag-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Tags', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[post_tag_weight]" id="post_tag_weight" value="<?php echo (float) $post_tag_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'author', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_author" data-check-value="search_author-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Author', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[author_weight]" id="author_weight" value="<?php echo (float) $author_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'comment', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_comment" data-check-value="search_comment-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Comments', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[comment_weight]" id="comment_weight" value="<?php echo (float) $comment_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'attachment', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_media" data-check-value="search_media-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Attachments', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[attachment_weight]" id="attachment_weight" value="<?php echo (float) $attachment_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'taxonomy', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_custom_taxonomy" data-check-value="search_custom_taxonomy-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Custom Taxonomy', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[taxonomy_weight]" id="taxonomy_weight" value="<?php echo (float) $taxonomy_weight; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse<?php if( !in_array( 'meta', $search_in ) ) echo ' js-hide'; ?>" data-check-field="search_custom_meta" data-check-value="search_custom_meta-1">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Custom Meta', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[meta_weight]" id="meta_weight" value="<?php echo (float) $meta_weight; ?>" />
                                                                </div>
                                                        </div>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Exclude Specific', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <div class="row collapse">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Categories', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="regular-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[exclude_category]" id="exclude_category" value="<?php echo esc_html( $exclude_category ); ?>" /><br />
                                                                        <span class="description"> <?php printf(__('Enter a comma separated list of category slugs to exclude from the search. Click <a href="%1$s" target="_blank">here</a> to see the list.', SEARCHFORD_SLUG), get_admin_url('','edit-tags.php?taxonomy=category')); ?></span>
                                                                </div>
                                                        </div>
                                                        <div class="row collapse">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Tags', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="regular-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[exclude_tag]" id="exclude_tag" value="<?php echo esc_html( $exclude_tag ); ?>" /><br />
                                                                        <span class="description"> <?php printf(__('Enter a comma separated list of tag slugs to exclude from the search. Click <a href="%1$s" target="_blank">here</a> to see the list.', SEARCHFORD_SLUG), get_admin_url('','edit-tags.php?taxonomy=post_tag')); ?></span>
                                                                </div>
                                                        </div>
                                                        <div class="row collapse">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Posts or Pages', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" class="regular-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[exclude_post]" id="exclude_post" value="<?php echo esc_html( $exclude_post ); ?>" /><br />
                                                                        <span class="description"> <?php _e('Enter a comma separated list of post or page IDs to exclude from the search.', SEARCHFORD_SLUG); ?></span>
                                                                </div>
                                                        </div>
                                                        <?php if( !empty( $taxonomies ) ): ?>
                                                                <?php for( $i = 0; $i < count( $taxonomies ); $i++ ): ?>
                                                                <?php $link = ${"exclude_taxonomy" . $i} == '' ? '' : get_admin_url('','edit-tags.php?taxonomy=' . ${"exclude_taxonomy" . $i}); ?>
                                                                <div id="taxonomy<?php echo $i; ?>" class="row collapse<?php if( $i != 0 && ${"exclude_taxonomy" . $i} == '' && ${"exclude_taxonomy_slug" . $i} == '' ) echo ' js-hide'; ?>">
                                                                        <div class="small-2 columns">
                                                                                <select id="exclude_taxonomy<?php echo $i; ?>" class="exclude-taxonomy" name="<?php echo SEARCHFORD_OPTIONS; ?>[exclude_taxonomy<?php echo $i; ?>]">
                                                                                        <option value=""><?php _e('Select Taxonomy'); ?></option>
                                                                                        <?php foreach( $taxonomies as $t ): ?>
                                                                                        <option value="<?php echo $t; ?>" <?php selected($t, ${"exclude_taxonomy" . $i}); ?>><?php echo $t; ?></option>
                                                                                        <?php endforeach; ?>
                                                                                </select>
                                                                        </div>
                                                                        <div class="small-9 columns">
                                                                                <input type="text" class="regular-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[exclude_taxonomy_slug<?php echo $i; ?>]" id="exclude_taxonomy_slug<?php echo $i; ?>" value="<?php echo esc_html( ${"exclude_taxonomy_slug" . $i} ); ?>" /><br />
                                                                                <span class="description"> <?php _e('Enter a comma separated list of custom taxonomy slugs to exclude from the search.', SEARCHFORD_SLUG); ?><span class="taxonomy-link<?php if( ${"exclude_taxonomy" . $i} == '' ) echo ' js-hide'; ?>"><?php printf(__('Click <a href="%1$s" target="_blank">here</a> to see the list.', SEARCHFORD_SLUG), $link); ?></span></span>
                                                                        </div>
                                                                        <div class="small-1 end columns">
                                                                                <?php if( $i != 0 ): ?>
                                                                                <button id="hide_taxonomy<?php echo $i; ?>" class="cmb-button small-button hide-taxonomy">&times;</button>
                                                                                <?php endif; ?>
                                                                        </div>
                                                                </div>
                                                                <?php endfor;?>
                                                        <p><button id="add_taxonomy" class="cmb-button"><?php _e('Add row', SEARCHFORD_SLUG); ?></button></p>
                                                        <?php endif; ?>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Stopwords', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <textarea id="stopwords" class="large-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[stopwords]"><?php echo esc_html( $stopwords ); ?></textarea>
                                                        <p class="description"><?php _e('Enter a comma separated list of stop words.', SEARCHFORD_SLUG); ?></p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('No Results Found', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <label for="no_results_default"><input type="radio" id="no_results_default" name="<?php echo SEARCHFORD_OPTIONS; ?>[no_results]" value="0" <?php checked($no_results, '0'); ?> /><?php _e('Default (No results found)', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="no_results_suggest"><input type="radio" id="no_results_suggest" name="<?php echo SEARCHFORD_OPTIONS; ?>[no_results]" value="1" <?php checked($no_results, '1'); ?> /><?php _e('Show Search Suggestion (Requires editing template page)', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="no_results_search"><input type="radio" id="no_results_search" name="<?php echo SEARCHFORD_OPTIONS; ?>[no_results]" value="2" <?php checked($no_results, '2'); ?> /><?php _e('Redirect to Suggested Search Results', SEARCHFORD_SLUG); ?></label>
                                                        </p>
                                                </td>
                                        </tr>
                                </table>
                        </div>
                        <div id="tabs-live">
                                <h4 class="description"><?php _e('These settings applies to the default search form and search plugin.', SEARCHFORD_SLUG); ?></h4>
                                <table class="form-table">
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Enable Live Search', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <p>
                                                                <input type="hidden" id="live_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[live]" value="0" />
                                                                <input type="checkbox" class="select-change" id="live" name="<?php echo SEARCHFORD_OPTIONS; ?>[live]" value="1" <?php checked($live, '1'); ?> />
                                                        </p>
                                                </td>
                                        </tr>
                                </table>
                                <table class="form-table <?php if( $live != '1' ) echo 'js-hide'; ?>" data-check-field="live" data-check-value="live-1">
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Dropdown Style', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <label for="live_style_list"><input type="radio" class="select-change" id="live_style_list" name="<?php echo SEARCHFORD_OPTIONS; ?>[live_style]" value="list" <?php checked($live_style, 'list'); ?> /><?php _e('List', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="live_style_masonry"><input type="radio" class="select-change" id="live_style_masonry" name="<?php echo SEARCHFORD_OPTIONS; ?>[live_style]" value="masonry" <?php checked($live_style, 'masonry'); ?> /><?php _e('Masonry', SEARCHFORD_SLUG); ?></label>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Display', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <input type="hidden" id="display_thumbnail_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[display_thumbnail]" value="<?php echo $display_thumbnail; ?>" />
                                                        <input type="hidden" id="display_title_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[display_title]" value="0" />
                                                        <input type="hidden" id="display_excerpt_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[display_excerpt]" value="0" />
                                                        <p>
                                                                <label for="display_thumbnail"><input type="checkbox" data-multi-change="masonry" id="display_thumbnail" name="<?php echo SEARCHFORD_OPTIONS; ?>[display_thumbnail]" value="1" <?php checked($display_thumbnail, '1'); ?> <?php disabled($live_style, 'masonry'); ?> /><?php _e('Thumbnail', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="display_title"><input type="checkbox" data-multi-change="masonry" id="display_title" name="<?php echo SEARCHFORD_OPTIONS; ?>[display_title]" value="1" <?php checked($display_title, '1'); ?> /><?php _e('Title', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="display_excerpt"<?php if( $live_style == 'masonry' ) echo ' class="js-hide"'; ?> data-check-field="live_style_masonry live_style_list" data-check-value="live_style_list-list"><input type="checkbox" data-multi-change="masonry" id="display_excerpt" name="<?php echo SEARCHFORD_OPTIONS; ?>[display_excerpt]" value="1" <?php checked($display_excerpt, '1'); ?> /><?php _e('Excerpt | Caption', SEARCHFORD_SLUG); ?></label><br />
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top"<?php if( $live_style == 'list' ) echo ' class="js-hide"'; ?> data-check-field="live_style_masonry live_style_list" data-check-value="live_style_masonry-masonry">
                                                <th scope="row"><?php _e('Masonry Columns', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <input type="text" id="masonry_columns" name="<?php echo SEARCHFORD_OPTIONS; ?>[masonry_columns]" value="<?php echo (int) $masonry_columns; ?>" />
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Max # of Results', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <input type="text" id="live_max" name="<?php echo SEARCHFORD_OPTIONS; ?>[live_max]" value="<?php echo esc_html( $live_max ); ?>" />
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Show Suggestions for 0 Results', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <input type="hidden" id="live_suggestion_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[live_suggestion]" value="0" />
                                                        <input type="checkbox" id="live_suggestion" name="<?php echo SEARCHFORD_OPTIONS; ?>[live_suggestion]" value="1" <?php checked($live_suggestion, '1'); ?> />
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Theme', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <label for="theme_light"><input type="radio" id="theme_light" name="<?php echo SEARCHFORD_OPTIONS; ?>[theme]" value="light" <?php checked($theme, 'light'); ?> /><?php _e('Light Theme', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="theme_dark"><input type="radio" id="theme_dark" name="<?php echo SEARCHFORD_OPTIONS; ?>[theme]" value="dark" <?php checked($theme, 'dark'); ?> /><?php _e('Dark Theme', SEARCHFORD_SLUG); ?></label>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Colors', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <div class="row collapse">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Background Color', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" id="background_color" class="colorpicker" name="<?php echo SEARCHFORD_OPTIONS; ?>[background_color]" value="<?php echo $background_color; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Accent Color', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" id="accent_color" class="colorpicker" name="<?php echo SEARCHFORD_OPTIONS; ?>[accent_color]" value="<?php echo $accent_color; ?>" />
                                                                </div>
                                                        </div>
                                                        <div class="row collapse">
                                                                <div class="small-2 columns">
                                                                        <?php _e('Font Color', SEARCHFORD_SLUG); ?>
                                                                </div>
                                                                <div class="small-10 end columns">
                                                                        <input type="text" id="font_color" class="colorpicker" name="<?php echo SEARCHFORD_OPTIONS; ?>[font_color]" value="<?php echo $font_color; ?>" />
                                                                </div>
                                                        </div>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Rounded Corners', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <input type="hidden" id="round_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[round]" value="0" />
                                                        <input type="checkbox" id="round" name="<?php echo SEARCHFORD_OPTIONS; ?>[round]" value="1" <?php checked($round, '1'); ?> />
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Display Search Tip', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <input type="hidden" id="search_tip_hidden" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_tip]" value="0" />
                                                        <input type="checkbox" id="search_tip" name="<?php echo SEARCHFORD_OPTIONS; ?>[search_tip]" value="1" <?php checked($search_tip, '1'); ?> />
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row">
                                                        <?php _e('Dropdown Width', SEARCHFORD_SLUG); ?>
                                                </th>
                                                <td>
                                                        <input type="text" id="width" class="small-text" name="<?php echo SEARCHFORD_OPTIONS; ?>[width]" value="<?php echo esc_html( $width ); ?>" /><?php _e('px', SEARCHFORD_SLUG); ?>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Dropdown Alignment to Search Form', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <label for="align_left"><input type="radio" id="align_left" name="<?php echo SEARCHFORD_OPTIONS; ?>[align]" value="left" <?php checked($align, 'left'); ?> /><?php _e('Left', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="align_right"><input type="radio" id="align_right" name="<?php echo SEARCHFORD_OPTIONS; ?>[align]" value="right" <?php checked($align, 'right'); ?> /><?php _e('Right', SEARCHFORD_SLUG); ?></label>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Custom Loading Image', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <ul class="image-preview clearfix">
                                                                <?php if ($loading_gif != ''): ?>
                                                                        <li id="loading_gif_preview">
                                                                                <?php echo wp_get_attachment_link( $loading_gif, 'thumb', true ); ?>
                                                                                <a href="javascript:;" id="delete_loading_gif" class="cmb-button small-button delete-media">&times;</a>
                                                                        </li>
                                                                <?php endif; ?>
                                                        </ul>
                                                        <div class="uploader clear<?php if ($loading_gif != '') echo ' js-hide'; ?>">
                                                                <a href="javascript:;" class="cmb-button default-button <?php echo ($loading_gif != '') ? 'disabled' : 'upload_image_button'; ?>"><?php _e('Upload', SEARCHFORD_SLUG); ?></a>
                                                        </div>
                                                        <input type="hidden" id="loading_gif" name="<?php echo SEARCHFORD_OPTIONS; ?>[loading_gif]" value="<?php echo $loading_gif; ?>" />
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Custom CSS', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <textarea class="code large-text" id="css" name="<?php echo SEARCHFORD_OPTIONS; ?>[css]"><?php echo esc_html( $css ); ?></textarea>
                                                </td>
                                        </tr>
                                        <input type="hidden" id="custom_css" name="<?php echo SEARCHFORD_OPTIONS; ?>[custom_css]" value="<?php echo esc_html( $custom_css ); ?>" />
                                </table>
                        </div>
                        <div id="tabs-index">
                                <h4 class="description"><?php _e('These settings applies to all searches.', SEARCHFORD_SLUG); ?></h4>
                                <table class="form-table">
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Post Statuses to Index', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <?php foreach( $statuses as $status => $l ): ?>
                                                                <label for="status_<?php echo $status; ?>"><input type="checkbox" id="status_<?php echo $status; ?>" value="<?php echo $status; ?>" name="<?php echo SEARCHFORD_OPTIONS; ?>[post_status][]" <?php if( in_array($status, $post_status) ) echo  'checked="checked"'; ?> /><?php echo $l; ?></label><br />
                                                                <?php endforeach; ?>
                                                                <span class="description"><?php _e('Database will be re-indexed automatically if this value is changed.', SEARCHFORD_SLUG); ?></span>
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Index Behaviour', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <label for="index_auto"><input type="radio" id="index_auto" name="<?php echo SEARCHFORD_OPTIONS; ?>[index]" value="auto" <?php checked($index, 'auto'); ?> /><?php _e('Automatically Index New / Updated Content', SEARCHFORD_SLUG); ?></label><br />
                                                                <label for="index_manual"><input type="radio" id="index_manual" name="<?php echo SEARCHFORD_OPTIONS; ?>[index]" value="manual" <?php checked($index, 'manual'); ?> /><?php _e('Manual Index', SEARCHFORD_SLUG); ?></label><span class="description"><br />
                                                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php _e('Recommended for posts/content that are updated more than once per 5 mintues', SEARCHFORD_SLUG); ?></span><br />
                                                        </p>
                                                </td>
                                        </tr>
                                        <tr valign="top">
                                                <th scope="row"><?php _e('Remove Data On Uninstallation', SEARCHFORD_SLUG); ?></th>
                                                <td>
                                                        <p>
                                                                <input type="hidden" id="remove_data_hidden" " name="<?php echo SEARCHFORD_OPTIONS; ?>[remove_data]" value="0" />
                                                                <input type="checkbox" id="remove_data" name="<?php echo SEARCHFORD_OPTIONS; ?>[remove_data]" value="1" <?php checked($remove_data, '1'); ?> />
                                                                <span class="description"><?php _e('Select this to delete all Searchford posts, settings and index from the database on plugin uninstallation. This cannot be undone. Once the data are deleted they will be gone forever.', SEARCHFORD_SLUG); ?></span>
                                                        </p>
                                                </td>
                                        </tr>
                                </table>
                                <h3><?php _e('Index Status', SEARCHFORD_SLUG); ?></h3>
                                <div class="row collapse">
                                        <div class="small-2 columns">
                                                <?php _e('Last Indexed Post ID:', SEARCHFORD_SLUG); ?>
                                        </div>
                                        <div class="small-10 end columns">
                                                <span id="max0"><?php echo $last0; ?></span>
                                        </div>
                                </div>
                                <div class="row collapse">
                                        <div class="small-2 columns">
                                                <?php _e('Last Indexed Page ID:', SEARCHFORD_SLUG); ?>
                                        </div>
                                        <div class="small-10 end columns">
                                                <span id="max1"><?php echo $last1; ?></span>
                                        </div>
                                </div>
                                <div class="row collapse">
                                        <div class="small-2 columns">
                                                <?php _e('Last Indexed Category ID:', SEARCHFORD_SLUG); ?>
                                        </div>
                                        <div class="small-10 end columns">
                                                <span id="max2"><?php echo $last2; ?></span>
                                        </div>
                                </div>
                                <div class="row collapse">
                                        <div class="small-2 columns">
                                                <?php _e('Last Indexed Tag ID:', SEARCHFORD_SLUG); ?>
                                        </div>
                                        <div class="small-10 end columns">
                                                <span id="max3"><?php echo $last3; ?></span>
                                        </div>
                                </div>
                                <div class="row collapse margin30">
                                        <div class="small-2 columns">
                                                <?php _e('Last Indexed Comment ID:', SEARCHFORD_SLUG); ?>
                                        </div>
                                        <div class="small-10 end columns">
                                                <span id="max4"><?php echo $last4; ?></span>
                                        </div>
                                </div>
                                <?php wp_nonce_field('searchford_create_index','searchford_create_index_nonce_field'); ?>
                                <button id="searchford_index_ajax"><?php _e('Index Database Now'); ?></button><span class="searchford-loading"></span><span class="description"> <?php _e('Save Changes before indexing for the changes to take effect', SEARCHFORD_SLUG); ?></span>
                        </div>
                        <?php submit_button(); ?>
                </form>
        </div>
</div>