<?php
/* ==========================================================================
   Actions
   ========================================================================== */
if ( !function_exists('searchford_admin_menu') ) {
        function searchford_admin_menu() {
                add_options_page(SEARCHFORD_NAME, 'Searchford', 'manage_options','searchford-settings', 'searchford_settings');
                add_action( 'admin_init', 'register_searchford_settings' );
     }
}

if ( !function_exists('searchford_add_custom_script') ) {
        function searchford_add_custom_script($hook) {
                global $post;
                
                if( $hook == 'settings_page_searchford-settings' ) {
                        wp_enqueue_media();
                        wp_enqueue_script( 'wp-color-picker' ); 
                        wp_enqueue_script( 'jquery-ui-core' );
                        wp_enqueue_script( 'jquery-ui-tabs' );
                        wp_enqueue_script('searchford_admin_js', SEARCHFORD_URL . 'admin/js/admin.js', '', '', true); 
                        wp_enqueue_style( 'wp-color-picker' );
                        wp_enqueue_style('searchford_meta_css', SEARCHFORD_URL . 'admin/css/meta.css');
                        
                        wp_localize_script('searchford_admin_js', 'cmb_vars', array(
                                        'mediaTitle' => __('Insert Image', SEARCHFORD_SLUG),
                                        'mediaButton' => __('Add image', SEARCHFORD_SLUG),
                                )
                        );
                }
                
                if( $hook == 'post-new.php' || $hook == 'post.php' ) {
                        
                        if( 'searchford' === $post->post_type ) {
                                wp_enqueue_media();
                                wp_enqueue_script( 'wp-color-picker' ); 
                                wp_enqueue_script( 'jquery-ui-core' );
                                wp_enqueue_script('searchford_admin_js', SEARCHFORD_URL . 'admin/js/admin.js', '', '', true); 
                                wp_enqueue_style( 'wp-color-picker' );
                                wp_enqueue_style('searchford_meta_css', SEARCHFORD_URL . 'admin/css/meta.css');
                                
                                wp_localize_script('searchford_admin_js', 'cmb_vars', array(
                                                'mediaTitle' => __('Insert Image', SEARCHFORD_SLUG),
                                                'mediaButton' => __('Add image', SEARCHFORD_SLUG),
                                        )
                                );
                        }
                }
        }
}

add_action( 'admin_menu', 'searchford_admin_menu' );
add_action( 'admin_enqueue_scripts', 'searchford_add_custom_script', 10, 1 );

/* ==========================================================================
   Settings
   ========================================================================== */
if( !function_exists('register_searchford_settings') ) {
        function register_searchford_settings() {
                //register our settings
               register_setting( SEARCHFORD_OPTIONS . '_group', SEARCHFORD_OPTIONS);
        }
}

if ( !function_exists('searchford_settings') ) {
        function searchford_settings() {
                if ( !current_user_can('manage_options') ) {
                        wp_die('You do not have sufficient permissions to access this page.');
                }
                
                $searchford_options = get_option( SEARCHFORD_OPTIONS );
                
                $meta_keys = array(
                        'sort' => 'relevance',
                        'search_in' => array('title','content','category','post_tag','comment'),
                        'roles' => array(),
                        'custom_meta' => '',
                        'custom_taxonomy' => array(),
                        'non_public' => '0',
                        'include' => array('post','page'),
                        'exclude_category' => '',
                        'exclude_tag' => '',
                        'exclude_post' => '',
                        'stopwords' => '',
                        'fuzzy' => '1',
                        'post_status' => array('publish'),
                        'no_results' => '1',
                        'title_weight' => '3',
                        'content_weight' => '2',
                        'category_weight' => '1',
                        'post_tag_weight' => '1',
                        'author_weight' => '0.5',
                        'comment_weight' => '0.5',
                        'attachment_weight' => '1',
                        'taxonomy_weight' => '1',
                        'meta_weight' => '1',
                        'highlight_title' => '1',
                        'highlight_excerpt' => '1',
                        'highlight_tags' => '1',
                        'highlight_author' => '1',
                        'highlight_style' => 'bold',
                        'highlight_text_color' => '',
                        'highlight_background_color' => '',
                        'highlight_css' => '',
                        'index' => 'auto',
                        'live' => '1',
                        'live_style' => 'list',
                        'live_suggestion' => '1',
                        'display_thumbnail' => '1',
                        'display_title' => '1',
                        'display_excerpt' => '',
                        'live_max' => '10',
                        'masonry_columns' => '3',
                        'theme' => 'light',
                        'font_color' => '',
                        'background_color' => '',
                        'accent_color' => '',
                        'round' => '1',
                        'width' => '',
                        'search_tip' => '1',
                        'align' => 'left',
                        'loading_gif' => '',
                        'css' => '',
                        'custom_css' => '',
                        'remove_data' => '0',
                );
                
                foreach ( $meta_keys as $meta_key => $default ) {
                        if( isset( $searchford_options[$meta_key] ) && '' != $searchford_options[$meta_key] ) {
                                $$meta_key = is_array( $searchford_options[$meta_key] ) ? $searchford_options[$meta_key] : esc_attr( $searchford_options[$meta_key] );
                        } else {
                                $$meta_key = $default;
                        }
                }
                
                $post_types = get_post_types('','objects');
                unset( $post_types['revision'], $post_types['nav_menu_item'], $post_types['searchford'] );
                
                $taxonomies = get_taxonomies();
                unset( $taxonomies['nav_menu'], $taxonomies['post_format'], $taxonomies['post_tag'], $taxonomies['category'] );

                for( $i = 0; $i < count( $taxonomies ); $i++ ) {

                        if( isset( $searchford_options['exclude_taxonomy' . $i] ) && '' != $searchford_options['exclude_taxonomy' . $i] ) {
                                ${"exclude_taxonomy" . $i} = $searchford_options['exclude_taxonomy' . $i];
                        } else {
                                ${"exclude_taxonomy" . $i} = '';
                        }
                        
                        if( isset( $searchford_options['exclude_taxonomy_slug' . $i] ) && '' != $searchford_options['exclude_taxonomy_slug' . $i] ) {
                                ${"exclude_taxonomy_slug" . $i} = $searchford_options['exclude_taxonomy_slug' . $i];
                        } else {
                                ${"exclude_taxonomy_slug" . $i} = '';
                        }
                }
                
                $statuses = get_post_statuses();
                $wp_roles = get_editable_roles();
                $last = searchford_get_last_indexed(); // get last indexed IDs
                for( $i = 0; $i < 5; $i++ ) {
                        ${"last" . $i} = isset( $last[$i]->max ) ? $last[$i]->max : __('Unavailable', SEARCHFORD_SLUG);
                }

                include_once(SEARCHFORD_PATH . 'admin/partials/searchford-admin-settings-display.php');
        }
}

if( !function_exists('searchford_update_option') ) {
        function searchford_update_option( $old_value, $new_value ) {

                if( $new_value['post_status'] != $old_value['post_status'] ||
                    $new_value['custom_meta'] != $old_value['custom_meta'] ||
                    in_array('meta', array_diff( $old_value['search_in'], $new_value['search_in'] )) ||
                    in_array('meta', array_diff( $new_value['search_in'], $old_value['search_in'] )) ) {
                        
                        global $wpdb;
                        $table = $wpdb->prefix . 'searchford';
                        
                        searchford_create_index($table);
                }

                // Generate custom css. If different from old one update static custom.css
                $css = $new_value['css'];
                $css .= $new_value['font_color'] == '' ? '' : '.searchford-box, .searchford-box.dark { color: ' . $new_value['font_color'] . '; }';
                $css .= $new_value['background_color'] == '' ? '' : '.searchford-box .searchford-content, .searchford-box .searchford-load, .searchford-box.dark .searchford-content, .searchford-box.dark .searchford-load { background: ' . $new_value['background_color'] . ';} .searchford-box .searchford-tip,.searchford-box.dark .searchford-tip { border-bottom-color: ' . $new_value['background_color'] . '; } .searchford-box .searchford-content .searchford-list li > a, .searchford-box.dark .searchford-content .searchford-list li > a{ border-left-color: ' . $new_value['background_color'] . ';}';
                $css .= $new_value['accent_color'] == '' ? '' : '.searchford-box .searchford-load .l1 div, .searchford-box .searchford-load .l2 div, .searchford-box .searchford-load .l3 div, .searchford-box .searchford-load .l4 div, .searchford-box .searchford-foot, .searchford-box.dark .searchford-cat, .searchford-box.dark .searchford-load .l1 div, .searchford-box.dark .searchford-load .l2 div, .searchford-box.dark .searchford-load .l3 div, .searchford-box.dark .searchford-load .l4 div, .searchford-box.dark .searchford-foot, .searchford-box .searchford-masonry-title, .searchford-box.dark .searchford-masonry-title { background-color: ' . $new_value['accent_color'] . '; } .searchford-box .searchford-content .searchford-list li > a:hover, .searchford-box.dark .searchford-content .searchford-list li > a:hover{ border-left-color: ' . $new_value['accent_color'] . ';}';
                $css .= $new_value['width'] == '' ? '' : '.searchford-box, .searchford-box.dark { width: ' . $new_value['width'] . 'px; }';
                
                if( $css != $old_value['custom_css'] ) {
                        $new_value['custom_css'] = $css;
                        update_option( SEARCHFORD_OPTIONS, $new_value );
                        searchford_update_static_css();
                }
        }
}

add_action( 'update_option_' . SEARCHFORD_OPTIONS, 'searchford_update_option', 10, 2 );

/* ==========================================================================
   Indexing
   ========================================================================== */
if( !function_exists('searchford_get_last_indexed') ) {
        function searchford_get_last_indexed() {
                
                global $wpdb;
                
                $table = $wpdb->prefix . 'searchford';
                return $wpdb->get_results("( SELECT object_id AS max
                                        FROM $table
                                        WHERE type='post'
                                        ORDER BY object_id DESC LIMIT 1 )
                                        UNION  
                                        ( SELECT object_id
                                        FROM $table
                                        WHERE type='page'
                                        ORDER BY object_id DESC LIMIT 1 )
                                        UNION  
                                        ( SELECT subtype
                                        FROM $table
                                        WHERE type='category'
                                        ORDER BY CAST( `subtype` AS SIGNED ) DESC LIMIT 1 )
                                        UNION  
                                        ( SELECT subtype
                                        FROM $table
                                        WHERE type='post_tag'
                                        ORDER BY CAST( `subtype` AS SIGNED ) DESC LIMIT 1 )
                                        UNION                                       
                                        ( SELECT subtype
                                        FROM $table
                                        WHERE type='comment'
                                        ORDER BY CAST( `subtype` AS SIGNED ) DESC LIMIT 1 )");
        }
}

if( !function_exists('searchford_get_CJK_ranges') ) {
        function searchford_get_CJK_ranges() {
                return array(
                        "[\x{2E80}-\x{2EFF}]",      # CJK Radicals Supplement
                        "[\x{2F00}-\x{2FDF}]",      # Kangxi Radicals
                        "[\x{2FF0}-\x{2FFF}]",      # Ideographic Description Characters
                        "[\x{3000}-\x{303F}]",      # CJK Symbols and Punctuation
                        "[\x{3040}-\x{309F}]",      # Hiragana
                        "[\x{30A0}-\x{30FF}]",      # Katakana
                        "[\x{3100}-\x{312F}]",      # Bopomofo
                        "[\x{3130}-\x{318F}]",      # Hangul Compatibility Jamo
                        "[\x{3190}-\x{319F}]",      # Kanbun
                        "[\x{31A0}-\x{31BF}]",      # Bopomofo Extended
                        "[\x{31F0}-\x{31FF}]",      # Katakana Phonetic Extensions
                        "[\x{3200}-\x{32FF}]",      # Enclosed CJK Letters and Months
                        "[\x{3300}-\x{33FF}]",      # CJK Compatibility
                        "[\x{3400}-\x{4DBF}]",      # CJK Unified Ideographs Extension A
                        "[\x{4DC0}-\x{4DFF}]",      # Yijing Hexagram Symbols
                        "[\x{4E00}-\x{9FFF}]",      # CJK Unified Ideographs
                        "[\x{A000}-\x{A48F}]",      # Yi Syllables
                        "[\x{A490}-\x{A4CF}]",      # Yi Radicals
                        "[\x{AC00}-\x{D7AF}]",      # Hangul Syllables
                        "[\x{F900}-\x{FAFF}]",      # CJK Compatibility Ideographs
                        "[\x{FE30}-\x{FE4F}]",      # CJK Compatibility Forms
                        "[\x{1D300}-\x{1D35F}]",    # Tai Xuan Jing Symbols
                        "[\x{20000}-\x{2A6DF}]",    # CJK Unified Ideographs Extension B
                        "[\x{2F800}-\x{2FA1F}]"     # CJK Compatibility Ideographs Supplement
                );
        
        }
}

if( !function_exists('searchford_contains_CJK') ) {
        function searchford_contains_CJK($string) {
                $regex = '/'.implode('|', searchford_get_CJK_ranges()).'/u';
                return preg_match($regex,$string);
        }
}

if( !function_exists('searchford_clean_string') ) {
        function searchford_clean_string($string) {
                return trim(preg_replace('/ +/', ' ', preg_replace('~[^\p{L}\p{N}]++~u', ' ', urldecode(html_entity_decode(strip_tags($string))))));
        }
}

if( !function_exists('searchford_utf2ucs') ) {
        function searchford_utf2ucs( $str, $s ) {
                $str = strtolower($str);
                $char = 'UTF-8';
                $arr = array();
                $out = "";
                $c = mb_strlen($str,$char);
                $t = false;
            
                for( $i =0; $i < $c; $i++ ){
                        $arr[] = mb_substr( $str, $i, 1, $char );
                }
            
                foreach( $arr as $i => $v ){
                        if( preg_match('/^[a-z0-9 .\-,!\?\"\'\(\)*~<>\+]+$/i', $v, $match) ) {
                                $out .= $v;
                                $t = preg_match('/[.\+\-,!\?\"\'\(\)*~<>]+$/i', $v) ? false : true;
                        }else{
                                if($t) $out .= " ";
                                if( isset( $s ) && $s ) $out .= "+";
                                $out .= bin2hex( iconv("UTF-8","UCS-2", $v) );
                                $out .= isset( $arr[$i + 1] ) && preg_match('/[.\+\-,!\?\"\'\(\)*~<>]+$/i', $arr[$i + 1]) ? "" : " ";
                                $t = false;
                        }
                }
                return $out;
        }
}

if( !function_exists('searchford_pad') )
{
        function searchford_pad( $string ) {
                if( searchford_contains_CJK( $string ) ) {
                        $string = searchford_utf2ucs( $string, false );
                }
                
                if (substr($string, 0, 1) == " ") {
                        return str_replace(" ", " " . SEARCHFORD_PREFIX, $string);
                } else {
                        return SEARCHFORD_PREFIX . str_replace(" ", " " . SEARCHFORD_PREFIX, $string);
                }
        }
}

if( !function_exists('searchford_create_index') ) {
        function searchford_create_index( $table ) {
                global $wpdb;
                
                $searchford_options = get_option( SEARCHFORD_OPTIONS );
                // all custom options
                $all_options = $wpdb->get_col( $wpdb->prepare( "
                        SELECT pm.meta_value FROM {$wpdb->postmeta} pm
                        LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
                        WHERE pm.meta_key = '%s' 
                        AND p.post_status = '%s' 
                        AND p.post_type = '%s'
                ", '_searchford_meta', 'publish', 'searchford' ) );
                
                $wpdb->query("TRUNCATE TABLE $table");
                $statuses = $searchford_options['post_status'];
                
                $post_types = get_post_types();
                unset( $post_types['revision'], $post_types['nav_menu_item'], $post_types['attachment'] );
                $i = $j = 0;
                $limit = 999;
                ${"data" . $i} = '';
                
                //Index posts, pages
                $post_types = implode("','", $post_types);
                $statuses = implode("','", $statuses);
                
                $posts = $wpdb->get_results("SELECT ID, post_title, post_content, post_status, post_type
                                               FROM $wpdb->posts
                                               WHERE post_type IN ('" . $post_types . "')
                                               AND post_status IN ('" . $statuses . "')");
                
                foreach( $posts as $p ) {
                        
                        if( $j > $limit ) {
                                $j = 0;
                                $i++;
                                ${"data" . $i} = '';
                        }
                        
                        ${"data" . $i} .= "('" . $p->ID . "',"
                                . "'" . $p->post_status . "',"
                                . "'" . $p->post_type . "',"
                                . '"title",'
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $p->post_title ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $p->post_title ) ) ) ) . "'"
                                . "),";
                                
                        $j++;
                                
                        if( '' != $p->post_content ) {
                                if( $j > $limit ) {
                                        $j = 0;
                                        $i++;
                                        ${"data" . $i} = '';
                                }
                                ${"data" . $i} .= "('" . $p->ID . "',"
                                        . "'" . $p->post_status . "',"
                                        . "'" . $p->post_type . "',"
                                        . "'content',"
                                        . "'" . searchford_pad( esc_sql( searchford_clean_string( $p->post_content ) ) ) . "',"
                                        . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $p->post_content ) ) ) ) . "'"
                                        . "),";
                                $j++;
                        }
                }
                
                //Index attachments
                $attachments = $wpdb->get_results("SELECT ID, post_title, post_content, post_status, post_type, post_mime_type, post_excerpt
                                               FROM $wpdb->posts
                                               WHERE post_type = 'attachment'");
                
                foreach( $attachments as $a ) {
                        
                        if( $j > $limit ) {
                                $j = 0;
                                $i++;
                                ${"data" . $i} = '';
                        }
                        
                        $content = $a->post_title . ' ' . $a->post_content . ' ' . $a->post_excerpt;
                        ${"data" . $i} .= "('" . $a->ID . "',"
                                . "'" . $a->post_status . "',"
                                . "'" . $a->post_type . "',"
                                . "'" . $a->post_mime_type . "',"
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $content ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $content ) ) ) ) . "'"
                                . "),";
                        $j++;
                }
                
                //Index taxonomies
                $taxonomies = get_taxonomies();
                unset( $taxonomies['nav_menu'], $taxonomies['post_format'] );
                $taxonomies = implode("','", $taxonomies);
                
                $obj_taxonomies = $wpdb->get_results("SELECT tr.object_id, t.name, tt.taxonomy, tt.term_taxonomy_id
                                               FROM $wpdb->term_relationships AS tr
                                               LEFT JOIN $wpdb->term_taxonomy AS tt ON tt.term_taxonomy_id = tr.term_taxonomy_id
                                               LEFT JOIN $wpdb->terms AS t ON t.term_id = tt.term_id
                                               WHERE tt.taxonomy IN ('" . $taxonomies . "')");

                foreach( $obj_taxonomies as $ot ) {
                        
                        if( $j > $limit ) {
                                $j = 0;
                                $i++;
                                ${"data" . $i} = '';
                        }
                        
                        if( $ot->taxonomy == 'category' || $ot->taxonomy == 'post_tag' ) {
                                ${"data" . $i} .= "('" . $ot->object_id . "',"
                                        . "'',"
                                        . "'" . $ot->taxonomy . "',"
                                        . "'" . $ot->term_taxonomy_id . "',"
                                        . "'" . searchford_pad( esc_sql( searchford_clean_string( $ot->name ) ) ).  "',"
                                        . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $ot->name ) ) ) ) . "'"
                                        . "),";
                        } else {
                                ${"data" . $i} .= "('" . $ot->object_id . "',"
                                        . "'" . $ot->taxonomy . "',"
                                        . "'taxonomy',"
                                        . "'" . $ot->term_taxonomy_id . "',"
                                        . "'" . searchford_pad( esc_sql( searchford_clean_string( $ot->name ) ) ) . "',"
                                        . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $ot->name ) ) ) ) . "'"
                                        . "),";
                        }
                        $j++;
                }
                
                //Index authors
                $users = $wpdb->get_results("SELECT posts.ID, posts.post_author, author.display_name, author.first_name, author.last_name, author.description, author.role
                                            FROM $wpdb->posts AS posts
                                            INNER JOIN (
                                                SELECT u.ID, u.display_name,
                                                max(case when um.`meta_key` = 'first_name' then um.meta_value end) first_name,
                                                max(case when um.`meta_key` = 'last_name' then um.meta_value end) last_name,
                                                max(case when um.`meta_key` = 'description' then um.meta_value end) description,
                                                max(case when um.`meta_key` = 'sf_capabilities' then um.meta_value end) role
                                                FROM $wpdb->users AS u
                                                LEFT JOIN $wpdb->usermeta AS um ON u.ID = um.user_id
                                                GROUP BY u.ID ) AS author ON author.ID = posts.post_author
                                            GROUP BY posts.ID");

                foreach( $users as $user ) {
                        $user_detail = $user->display_name . ' ' . $user->first_name . ' ' . $user->last_name . ' ' . $user->description;
                        $user_role = '';
                        if( is_array(unserialize( $user->role )) ) {
                                $role = array_keys( unserialize( $user->role ) );
                                $user_role = $role[0];
                        }
                        
                        if( $j > $limit ) {
                                $j = 0;
                                $i++;
                                ${"data" . $i} = '';
                        }
                        
                        ${"data" . $i} .= "('" . $user->ID . "',"
                                . "'" . $user->post_author . "',"
                                . "'author',"
                                . "'" . $user_role . "',"
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( trim( $user_detail ) ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( trim( $user_detail ) ) ) ) ) . "'"
                                . "),";
                                
                        $j++;
                }
                
                //Index comments
                $comments = $wpdb->get_results("SELECT comment_post_ID, comment_content, comment_type, comment_ID
                                            FROM $wpdb->comments
                                            WHERE comment_approved = '1'");
                
                foreach( $comments as $comment ) {
                        if( $j > $limit ) {
                                $j = 0;
                                $i++;
                                ${"data" . $i} = '';
                        }
                        
                        ${"data" . $i} .= "('" . $comment->comment_post_ID . "',"
                                . "'" . $comment->comment_type . "',"
                                . "'comment',"
                                . "'" . $comment->comment_ID . "',"
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $comment->comment_content ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $comment->comment_content ) ) ) ) . "'"
                                . "),";
                        $j++;
                }
                
                //Index custom meta
                $meta = $searchford_options['custom_meta'] != '' && in_array('meta', $searchford_options['search_in']) ? $searchford_options['custom_meta'] : '';
                foreach( $all_options as $option ) {
                        $option = unserialize( $option );
                        $meta .= isset( $option['custom_meta']) && $option['custom_meta'] != '' && in_array('meta', $option['search_in']) ? ',' . $option['custom_meta'] : '';
                }
                if( '' != $meta ) {
                        $custom_meta = array_unique( array_map( 'trim', explode(',', trim( $meta, ',')) ) );
                        $custom_string = '';
                        
                        foreach( $custom_meta as $cm ) {
                                $custom_string .= "meta_key LIKE '" . $cm . "' OR ";
                        }
                        $custom_string = rtrim( $custom_string, ' OR ');
                        //$custom_meta = implode("','", $custom_meta);
                        
                        $custom_query = $wpdb->get_results("SELECT post_id, meta_key, meta_value
                                            FROM $wpdb->postmeta
                                            WHERE $custom_string");
                        
                        foreach( $custom_query as $cm ) {
                                if( $cm->meta_value != '' ) {
                                        if( $j > $limit ) {
                                                $j = 0;
                                                $i++;
                                                ${"data" . $i} = '';
                                        }
                                        
                                        ${"data" . $i} .= "('" . $cm->post_id . "',"
                                                . "'',"
                                                . "'meta',"
                                                . "'" . $cm->meta_key . "',"
                                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $cm->meta_value ) ) ) . "',"
                                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $cm->meta_value ) ) ) ) . "'"
                                                . "),";
                                        $j++;
                                }
                        }
                }
                
                $total = 0;
                $wpdb->query("ALTER TABLE $table DISABLE KEYS;");
                for( $k = 0; $k <= $i; $k++ ) {
                        $data = rtrim( ${"data" . $k}, ',' );
                        if( $count = $wpdb->query("INSERT INTO $table
                                     (`object_id`,`post_status`,`type`,`subtype`,`text`,`text_reverse`)
                                     VALUES $data")) {
                                $total += $count;
                        } else {
                                $wpdb->query("ALTER TABLE $table ENABLE KEYS;");
                                return __('An error has occurred during the indexing process.', SEARCHFORD_SLUG);
                        }
                }
                
                $wpdb->query("ALTER TABLE $table ENABLE KEYS;");
                return sprintf(__('%d rows have been indexed.', SEARCHFORD_SLUG), $total);
        }
}

if( !function_exists('searchford_ajax_create_index') ) {
        function searchford_ajax_create_index() {
                
                if ( empty($_POST['nonce']) || ! wp_verify_nonce( $_POST['nonce'], 'searchford_create_index' ) ) {
                        exit("Not verified");
                }
                
                global $wpdb;
                $table = $wpdb->prefix . 'searchford';
                
                echo json_encode( array(
                                        'success' => searchford_create_index($table),
                                        'max' => searchford_get_last_indexed(),
                                ));
                
                wp_die();
        }
}

if( !function_exists('searchford_reverse') ) {
        function searchford_reverse( $string ) {
                preg_match_all('/./us', $string, $ar);
                return join('',array_reverse($ar[0]));
        }
}

add_action( 'wp_ajax_searchford_index', 'searchford_ajax_create_index' );

/* ==========================================================================
   Auto Index
   ========================================================================== */
if( !function_exists('searchford_delete_index') ) {
        function searchford_delete_index( $id, $type = null ) {
                
                if( $type ) {
                        global $wpdb;
                        
                        $table = $wpdb->prefix . 'searchford';
                        $where = '';
                        
                        switch( $type ) {
                                case 'post':
                                        $where = "WHERE object_id=$id AND type!='attachment' AND type!='comment'";
                                        break;
                                case 'comment':
                                        $where = "WHERE object_id=$id AND type='comment'";
                                        break;
                                case 'attachment':
                                        $where = "WHERE object_id=$id AND type='attachment'";
                                        break;
                        }
                        
                        if( '' != $where ) {
                                $wpdb->get_results("DELETE FROM $table $where;");
                        }
                }
        }
}

if( !function_exists('searchford_update_index') ) {
        function searchford_update_index( $post_id ) {
                // Bail if we're doing an auto save  
                if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return $post_id;
                
                searchford_delete_index( $post_id, 'post' ); //remove all old indexes
                
                $searchford_options = get_option( SEARCHFORD_OPTIONS );
                $option_status = $searchford_options['post_status'];

                if( isset( $_POST['post_status'] ) && in_array( $_POST['post_status'], $option_status ) ) {
                        
                        global $wpdb;
                        $data = '';
                        // all custom options
                        $all_options = $wpdb->get_col( $wpdb->prepare( "
                                SELECT pm.meta_value FROM {$wpdb->postmeta} pm
                                LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
                                WHERE pm.meta_key = '%s' 
                                AND p.post_status = '%s' 
                                AND p.post_type = '%s'
                        ", '_searchford_meta', 'publish', 'searchford' ) );
                        
                        //Add post index
                        $data .= "('" . $post_id . "',"
                                . "'" . $_POST['post_status'] . "',"
                                . "'" . $_POST['post_type'] . "',"
                                . '"title",'
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $_POST['post_title'] ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $_POST['post_title'] ) ) ) ) . "'"
                                . "),";
                                
                        if( isset( $_POST['post_content'] ) && '' != $_POST['post_content'] ) {
                                $data .= "('" . $post_id . "',"
                                        . "'" . $_POST['post_status'] . "',"
                                        . "'" . $_POST['post_type'] . "',"
                                        . '"content",'
                                        . "'" . searchford_pad( esc_sql( searchford_clean_string( $_POST['post_content'] ) ) ) . "',"
                                        . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $_POST['post_content'] ) ) ) ) . "'"
                                        . "),";
                        }
                        
                        //Add category
                        if( isset( $_POST['post_category'] ) && !empty( $_POST['post_category'] ) ) {
                                foreach( $_POST['post_category'] as $cat_id ) {
                                        if( is_string( $cat = get_the_category_by_ID( $cat_id )) ) {
                                                $data .= "('" . $post_id . "',"
                                                        . "'',"
                                                        . "'category',"
                                                        . "'" . $cat_id . "',"
                                                        . "'" . searchford_pad( $cat ) . "',"
                                                        . "'" . searchford_reverse( $cat ) . "'"
                                                        . "),";
                                        }
                                }
                        }
                        
                        //Add post_tag
                        $tags = wp_get_post_tags( $post_id );
                        foreach( $tags as $tag ) {
                                if( is_object( $tag ) ) {
                                        $data .= "('" . $post_id . "',"
                                                . "'',"
                                                . "'post_tag',"
                                                . "'" . $tag->term_taxonomy_id . "',"
                                                . "'" . searchford_pad( $tag->name ) . "',"
                                                . "'" . searchford_reverse( $tag->name ) . "'"
                                                . "),";
                                }
                        }
                        
                        //Add author
                        $post = get_post( $post_id );
                        $author = $post->post_author;
                        $user = $wpdb->get_results("SELECT u.ID, u.display_name,
                                                max(case when um.`meta_key` = 'first_name' then um.meta_value end) first_name,
                                                max(case when um.`meta_key` = 'last_name' then um.meta_value end) last_name,
                                                max(case when um.`meta_key` = 'description' then um.meta_value end) description,
                                                max(case when um.`meta_key` = 'sf_capabilities' then um.meta_value end) role
                                                FROM $wpdb->users AS u
                                                LEFT JOIN $wpdb->usermeta AS um ON u.ID = um.user_id
                                                WHERE u.ID = $author
                                                LIMIT 1;");
                        
                        $user_detail = $user[0]->display_name . ' ' . $user[0]->first_name . ' ' . $user[0]->last_name . ' ' . $user[0]->description;
                        $user_role = '';
                        if( is_array(unserialize( $user[0]->role )) ) {
                                $role = array_keys( unserialize( $user[0]->role ) );
                                $user_role = $role[0];
                        }

                        $data .= "('" . $post_id . "',"
                                . "'" . $author . "',"
                                . "'author',"
                                . "'" . $user_role . "',"
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( trim( $user_detail ) ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( trim( $user_detail ) ) ) ) ) . "'"
                                . "),";
                        
                        
                        //Add custom taxonomy
                        $custom_tax = isset( $searchford_options['custom_taxonomy'] ) ? $searchford_options['custom_taxonomy'] : array();
                        foreach( $custom_tax as $ct ) {
                                $terms = get_the_terms( $post_id, $ct );
                                foreach( $terms as $term ) {
                                        $data .= "('" . $post_id . "',"
                                                . "'" . $term->taxonomy . "',"
                                                . "'taxonomy',"
                                                . "'" . $term->term_taxonomy_id . "',"
                                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $term->name ) ) ) . "',"
                                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $term->name ) ) ) ) . "'"
                                                . "),"; 
                                }
                        }
                        
                        //Add custom meta
                        $meta = $searchford_options['custom_meta'] != '' && in_array('meta', $searchford_options['search_in']) ? $searchford_options['custom_meta'] : '';
                        foreach( $all_options as $option ) {
                                $option = unserialize( $option );
                                $meta .= isset( $option['custom_meta']) && $option['custom_meta'] != '' && in_array('meta', $option['search_in']) ? ',' . $option['custom_meta'] : '';
                        }
                        if( '' != $meta ) {
                                $custom_meta = array_unique( array_map( 'trim', explode(',', trim( $meta, ',' )) ) );
                                $post_meta = get_post_custom( $post_id );
                                
                                foreach( $custom_meta as $cm ) {
                                        if( array_key_exists( $cm, $post_meta ) && isset( $post_meta[ $cm ][0] ) && '' != $post_meta[ $cm ][0] ) {
                                               $data .= "('" . $post_id . "',"
                                                        . "'',"
                                                        . "'meta',"
                                                        . "'" . $cm . "',"
                                                        . "'" . searchford_pad( esc_sql( searchford_clean_string( $post_meta[ $cm ][0] ) ) ) . "',"
                                                        . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $post_meta[ $cm ][0] ) ) ) ) . "'"
                                                        . "),"; 
                                        }
                                }
                        }
                        $data = rtrim( $data, ',' );

                        //Insert new indexes
                        $table = $wpdb->prefix . 'searchford';
                        $wpdb->query("INSERT INTO $table (`object_id`,`post_status`,`type`,`subtype`,`text`,`text_reverse`)
                                     VALUES $data");
                }
        }
}

if( !function_exists('searchford_remove_index') ) {
        function searchford_remove_index( $post_id ) {
                searchford_delete_index( $post_id );
        }
}

if( !function_exists('searchford_update_attachment_index') ) {
        function searchford_update_attachment_index( $attachment_id ) {
                
                searchford_delete_index( $attachment_id, 'attachment' );
                
                if( $img = get_post( $attachment_id ) ) {
                        $content = $img->post_title . ' ' . $img->post_content . ' ' . $img->post_excerpt;
                        $data = "('" . $img->ID . "',"
                                . "'" . $img->post_status . "',"
                                . "'" . $img->post_type . "',"
                                . "'" . $img->post_mime_type . "',"
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $content ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $content ) ) ) ) . "'"
                                . ")";
                                
                        //Insert new indexes
                        global $wpdb;
                        $table = $wpdb->prefix . 'searchford';
                        $wpdb->query("INSERT INTO $table (`object_id`,`post_status`,`type`,`subtype`,`text`,`text_reverse`)
                                     VALUES $data");
                }
        }
}

if( !function_exists('searchford_update_comment_index') ) {
        function searchford_update_comment_index( $post_id ) {
                
                searchford_delete_index( $post_id, 'comment' );
                
                $comments = get_comments(array(
                        'status' => 'approve',
                        'post_id' => $post_id
                ));
                
                $data = '';
                foreach( $comments as $comment ) {
                
                        $data .= "('" . $post_id . "',"
                                . "'" . $comment->comment_type . "',"
                                . "'comment',"
                                . "'" . $comment->comment_ID . "',"
                                . "'" . searchford_pad( esc_sql( searchford_clean_string( $comment->comment_content ) ) ) . "',"
                                . "'" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( $comment->comment_content ) ) ) ) . "'"
                                . "),";
                        
                }
                
                if( '' != $data ) {
                        $data = rtrim( $data, ',' );
                                
                        //Insert new indexes
                        global $wpdb;
                        $table = $wpdb->prefix . 'searchford';
                        $wpdb->query("INSERT INTO $table (`object_id`,`post_status`,`type`,`subtype`,`text`,`text_reverse`)
                                     VALUES $data");
                }
        }
}

if( !function_exists('searchford_update_author_index') ) {
        function searchford_update_author_index( $user_id ) {
                
                global $wpdb;
                $user = $wpdb->get_results("SELECT u.ID, u.display_name,
                                            max(case when um.`meta_key` = 'first_name' then um.meta_value end) first_name,
                                            max(case when um.`meta_key` = 'last_name' then um.meta_value end) last_name,
                                            max(case when um.`meta_key` = 'description' then um.meta_value end) description,
                                            max(case when um.`meta_key` = 'sf_capabilities' then um.meta_value end) role
                                            FROM $wpdb->users AS u
                                            LEFT JOIN $wpdb->usermeta AS um ON u.ID = um.user_id
                                            WHERE u.ID = $user_id
                                            LIMIT 1");

                $user_detail = $user[0]->display_name . ' ' . $user[0]->first_name . ' ' . $user[0]->last_name . ' ' . $user[0]->description;
                $user_role = '';
                if( is_array(unserialize( $user[0]->role )) ) {
                        $role = array_keys( unserialize( $user[0]->role ) );
                        $user_role = $role[0];
                }

                $table = $wpdb->prefix . 'searchford';
                $wpdb->query("UPDATE $table
                             SET subtype = '" . $user_role . "',
                             text = '" . searchford_pad( esc_sql( searchford_clean_string( trim( $user_detail ) ) ) ) . "',
                             text_reverse = '" . esc_sql( searchford_reverse( searchford_pad( searchford_clean_string( trim( $user_detail ) ) ) ) ) . "'
                             WHERE post_status = $user_id AND type = 'author';");
                
        }
}

$searchford_options = get_option( SEARCHFORD_OPTIONS );
if ( $searchford_options['index'] == 'auto') {
        add_action( 'save_post', 'searchford_update_index' );
        add_action( 'deleted_post', 'searchford_remove_index');
        add_action( 'add_attachment', 'searchford_update_attachment_index');
        add_action( 'edit_attachment', 'searchford_update_attachment_index');
        add_action( 'edit_post', 'searchford_update_comment_index');
        add_action( 'profile_update', 'searchford_update_author_index');
}

/* ==========================================================================
   Searchford Post Type
   ========================================================================== */
add_action('init', 'searchford_register'); //Add custom post type
add_filter('manage_edit-searchford_columns', 'searchford_edit_columns' ); //Display custom columns in room admin view
add_action('manage_searchford_posts_custom_column', 'searchford_custom_columns', 10, 2 );

if ( !function_exists('searchford_register') )
{
        function searchford_register() {
                $labels = array(
                        'name'                  => __( 'Searchford', SEARCHFORD_SLUG ),
                        'singular_name'         => __( 'Search', SEARCHFORD_SLUG ),
                        'add_new'               => __( 'Add New Search', SEARCHFORD_SLUG ),
                        'add_new_item'          => __( 'Add New Search', SEARCHFORD_SLUG ),
                        'edit_item'             => __( 'Edit Search', SEARCHFORD_SLUG ),
                        'new_item'              => __( 'New Search', SEARCHFORD_SLUG ),
                        'view_item'             => __( 'View Search', SEARCHFORD_SLUG ),
                        'search_items'          => __( 'Search', SEARCHFORD_SLUG ),
                        'not_found'             => __( 'No search found', SEARCHFORD_SLUG ),
                        'not_found_in_trash'    => __( 'No search found in trash', SEARCHFORD_SLUG )
                );
                
                $args = array(
                        'labels'                 => $labels,
                        'public'                => false,
                        'show_ui'               => true,
                        'capability_type'       => 'post',
                        'hierarchical'          => false,
                        'supports'              => array('title'),
                        'menu_icon'             => 'dashicons-search',
                        'rewrite'               => array('slug' => 'searchford'),
                        'has_archive'           => false,
                        'exclude_from_search'   => true,
                        'publicly_queryable'    => false,
                        'show_in_nav_menus'     => false,
                        'show_in_menu'          => true,
                        'show_in_admin_bar'     => true,
                );
                
                register_post_type('searchford', $args);
        }
}

if (!function_exists('searchford_edit_columns'))
{
        function searchford_edit_columns($columns){
                $columns = array(
                        "cb" => "<input type=\"checkbox\" />",
                        "title" => _x('Title', SEARCHFORD_SLUG),
                        "shortcode" => _x('Shortcode',SEARCHFORD_SLUG),
                        "date" => _x('Date', SEARCHFORD_SLUG),
                );  
        
                return $columns;
        }
}

if (!function_exists('searchford_custom_columns'))
{
        function searchford_custom_columns( $columns, $post_id ){
           
                switch ( $columns )
                {
                        case "shortcode":
                                echo "[searchford id='$post_id']";
                                break;
                }
        }
}

/* ==========================================================================
   Add Searchford Meta
   ========================================================================== */
if (!function_exists('searchford_add_meta'))
{
        function searchford_add_meta(){
                global $post;
                if( isset( $post ) && $post->post_status == 'publish' ) {
                        add_meta_box("searchford_shortcode_meta", "Shortcode", "searchford_shortcode_meta_options", "searchford", "normal", "high");
                }
                
                add_meta_box("searchford_appearance_meta", "Search Form Appearance", "searchford_appearance_meta_options", "searchford", "normal", "high");
                add_meta_box("searchford_meta", "Custom Search Options", "searchford_meta_options", "searchford", "normal", "high");
                add_meta_box("searchford_live_meta", "Live Search Options", "searchford_live_meta_options", "searchford", "normal", "high");
        }
}

if( !function_exists('searchford_shortcode_meta_options') ) {
        function searchford_shortcode_meta_options() {
                global $post;
                if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post->ID;

                include_once(SEARCHFORD_PATH . '/admin/partials/searchford-admin-metabox-shortcode-display.php');
        }
}

if( !function_exists('searchford_appearance_meta_options') ) {
        function searchford_appearance_meta_options() {
                global $post; // refers to the post or parent being displayed
                if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post->ID;
                
                $custom = get_post_meta( $post->ID, '_searchford_meta', true);
                
                // List all custom meta keys
                $meta_keys = array(
                        'submit' => '',
                        'submit_label' => '',
                        'placeholder' => '',
                );
                
                foreach ( $meta_keys as $meta_key => $default ) {
                        $$meta_key = isset( $custom[$meta_key] ) && '' != $custom[$meta_key] ? esc_attr( $custom[$meta_key] ) : $default;
                }
                
                include_once(SEARCHFORD_PATH . '/admin/partials/searchford-admin-metabox-appearance-display.php');
        }
}

if (!function_exists('searchford_meta_options'))
        {
        function searchford_meta_options(){ //Create media upload meta box
                global $post; // refers to the post or parent being displayed
                if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post->ID;
                
                $custom = get_post_meta( $post->ID, '_searchford_meta', true);

                // List all custom meta keys
                $meta_keys = array(
                        'results_page' => '',
                        'sort' => 'relevance',
                        'search_in' => array('title','content','category','post_tag','comment'),
                        'roles' => array(),
                        'custom_meta' => '',
                        'custom_taxonomy' => array(),
                        'non_public' => '0',
                        'include' => array('post','page'),
                        'exclude_category' => '',
                        'exclude_tag' => '',
                        'exclude_post' => '',
                        'stopwords' => '',
                        'fuzzy' => '1',
                        'no_results' => '1',
                        'title_weight' => '3',
                        'content_weight' => '2',
                        'category_weight' => '1',
                        'post_tag_weight' => '1',
                        'author_weight' => '0.5',
                        'comment_weight' => '0.5',
                        'attachment_weight' => '1',
                        'taxonomy_weight' => '1',
                        'meta_weight' => '1',
                        'highlight_title' => '1',
                        'highlight_excerpt' => '1',
                        'highlight_tags' => '1',
                        'highlight_author' => '1',
                        'highlight_style' => 'bold',
                        'highlight_text_color' => '',
                        'highlight_background_color' => '',
                        'highlight_css' => '',
                );
                
                foreach ( $meta_keys as $meta_key => $default ) {
                        if( isset( $custom[$meta_key] ) && '' != $custom[$meta_key] ) {
                                $$meta_key = is_array( $custom[$meta_key] ) ? $custom[$meta_key] : esc_attr( $custom[$meta_key] );
                        } else {
                                $$meta_key = $default;
                        }
                }
                
                // Get post types
                $post_types = get_post_types('','objects');
                unset( $post_types['revision'], $post_types['nav_menu_item'], $post_types['searchford'] );
                
                // Get taxonomies
                $taxonomies = get_taxonomies();
                unset( $taxonomies['nav_menu'], $taxonomies['post_format'], $taxonomies['post_tag'], $taxonomies['category'] );

                for( $i = 0; $i < count( $taxonomies ); $i++ ) {

                        if( isset( $custom['exclude_taxonomy' . $i] ) && '' != $custom['exclude_taxonomy' . $i] ) {
                                ${"exclude_taxonomy" . $i} = $custom['exclude_taxonomy' . $i];
                        } else {
                                ${"exclude_taxonomy" . $i} = '';
                        }
                        
                        if( isset( $custom['exclude_taxonomy_slug' . $i] ) && '' != $custom['exclude_taxonomy_slug' . $i] ) {
                                ${"exclude_taxonomy_slug" . $i} = $custom['exclude_taxonomy_slug' . $i];
                        } else {
                                ${"exclude_taxonomy_slug" . $i} = '';
                        }
                }

                // Get editable roles
                $wp_roles = get_editable_roles();
                
                // Get page templates
                $templates = array();
                $page_templates = get_page_templates();
        
                foreach( $page_templates as $name => $filename ) {
                        $templates[] = $filename;
                }
                
                $stylesheet = get_stylesheet();
                $theme = wp_get_theme( $stylesheet );
                $allowed_files = $theme->get_files( 'php', 1 ); // this will only return .php files extend as needed
                
                foreach( $allowed_files as $k => $v ) {
                        $templates[] = $k;
                }
                
                $templates = array_unique( $templates );

                include_once(SEARCHFORD_PATH . '/admin/partials/searchford-admin-metabox-display.php');
        }
}

if( !function_exists('searchford_live_meta_options') ) {
        function searchford_live_meta_options() {
                global $post; // refers to the post or parent being displayed
                if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) return $post->ID;
                
                $custom = get_post_meta( $post->ID, '_searchford_meta', true);
                
                // List all custom meta keys
                $meta_keys = array(
                        'live' => '1',
                        'live_style' => 'list',
                        'live_suggestion' => '1',
                        'display_thumbnail' => '1',
                        'display_title' => '1',
                        'display_excerpt' => '',
                        'live_max' => '10',
                        'masonry_columns' => '3',
                        'theme' => 'light',
                        'font_color' => '',
                        'background_color' => '',
                        'accent_color' => '',
                        'round' => '1',
                        'width' => '',
                        'search_tip' => '1',
                        'align' => 'left',
                        'loading_gif' => '',
                );
                
                foreach ( $meta_keys as $meta_key => $default ) {
                        if( isset( $custom[$meta_key] ) && '' != $custom[$meta_key] ) {
                                $$meta_key = is_array( $custom[$meta_key] ) ? $custom[$meta_key] : esc_attr( $custom[$meta_key] );
                        } else {
                                $$meta_key = $default;
                        }
                }
                
                include_once(SEARCHFORD_PATH . '/admin/partials/searchford-admin-metabox-live-display.php');
        }
}

add_action('add_meta_boxes', 'searchford_add_meta');

/* ==========================================================================
   Save Searchford meta
   ========================================================================== */
add_action('save_post', 'searchford_save_meta'); 

if (!function_exists('searchford_save_meta'))
{
        function searchford_save_meta( $post_id ){          
        
                // Bail if we're doing an auto save  
                if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return $post_id;
           
                // if our nonce isn't there, or we can't verify it, bail 
                if( !isset( $_POST['save_searchford_meta_nonce_field'] ) || !wp_verify_nonce( $_POST['save_searchford_meta_nonce_field'], 'save_searchford_meta_' . $post_id ) ) return $post_id; 
        
                if (!current_user_can('edit_post', $post_id)) return $post_id;

                //list of the meta keys
                $meta_keys = array(
                        'submit',
                        'submit_label',
                        'placeholder',
                        'results_page',
                        'sort',
                        'search_in',
                        'roles',
                        'custom_taxonomy',
                        'custom_meta',
                        'non_public',
                        'include',
                        'exclude_category',
                        'exclude_tag',
                        'exclude_post',
                        'stopwords',
                        'fuzzy',
                        'no_results',
                        'title_weight',
                        'content_weight',
                        'category_weight',
                        'post_tag_weight',
                        'author_weight',
                        'comment_weight',
                        'attachment_weight',
                        'taxonomy_weight',
                        'meta_weight',
                        'highlight_title',
                        'highlight_excerpt',
                        'highlight_tags',
                        'highlight_author',
                        'highlight_style',
                        'highlight_text_color',
                        'highlight_background_color',
                        'highlight_css',
                        'live',
                        'live_style',
                        'live_suggestion',
                        'display_thumbnail',
                        'display_title',
                        'display_excerpt',
                        'live_max',
                        'masonry_columns',
                        'theme',
                        'font_color',
                        'background_color',
                        'accent_color',
                        'round',
                        'width',
                        'search_tip',
                        'align',
                        'loading_gif',
                );
                
                // Array of new values
                $saved_meta = array();
                $posts = $_POST[ SEARCHFORD_OPTIONS ];

                foreach ( $meta_keys as $meta_key ) {
                        if ( isset( $posts[$meta_key]  )) {
                                $saved_meta[ $meta_key ] = is_array( $posts[$meta_key] ) ? $posts[$meta_key] : sanitize_text_field( $posts[$meta_key] );
                        }
                }
                
                // Save taxonomies
                $taxonomies = get_taxonomies();
                unset( $taxonomies['nav_menu'], $taxonomies['post_format'], $taxonomies['post_tag'], $taxonomies['category'] );

                for( $i = 0; $i < count( $taxonomies ); $i++ ) {
                        if( isset( $posts['exclude_taxonomy' . $i] ) && '' != $posts['exclude_taxonomy' . $i] ) {
                                $saved_meta[ "exclude_taxonomy" . $i ] = sanitize_text_field( $posts["exclude_taxonomy" . $i] );
                        }
                        
                        if( isset( $posts['exclude_taxonomy_slug' . $i] ) && '' != $posts['exclude_taxonomy_slug' . $i] ) {
                                $saved_meta[ "exclude_taxonomy_slug" . $i ] = sanitize_text_field( $posts["exclude_taxonomy_slug" . $i] );
                        }
                }
                
                $old_value = get_post_meta( $post_id, '_searchford_meta', true );
                update_post_meta( $post_id, '_searchford_meta', $saved_meta );
                
                // Re-index if custom meta is changed
                if( $old_value ) {
                        if( $saved_meta['custom_meta'] != $old_value['custom_meta'] ||
                            in_array('meta', array_diff( $old_value['search_in'], $saved_meta['search_in'] )) ||
                            in_array('meta', array_diff( $saved_meta['search_in'], $old_value['search_in'] )) ) {
                                
                                global $wpdb;
                                $table = $wpdb->prefix . 'searchford';
                                
                                searchford_create_index($table);
                        }
                }

                // Generate custom css. If different from old one update static custom.css
                $css = '';
                $css .= $posts['font_color'] == '' ? '' : '#searchford_box' . $post_id . '{ color: ' . $posts['font_color'] . '; }';
                $css .= $posts['background_color'] == '' ? '' : '#searchford_box' . $post_id . ' .searchford-content, #searchford_box' . $post_id . ' .searchford-load { background: ' . $posts['background_color'] . ';} #searchford_box' . $post_id . ' .searchford-tip { border-bottom-color: ' . $posts['background_color'] . '; } #searchford_box' . $post_id . ' .searchford-content .searchford-list li > a:not(:hover) { border-left-color: ' . $posts['background_color'] . ';}';
                $css .= $posts['accent_color'] == '' ? '' : '#searchford_box' . $post_id . ' .searchford-load .l1 div, #searchford_box' . $post_id . ' .searchford-load .l2 div, #searchford_box' . $post_id . ' .searchford-load .l3 div, #searchford_box' . $post_id . ' .searchford-load .l4 div, #searchford_box' . $post_id . ' .searchford-foot, #searchford_box' . $post_id . ' .searchford-masonry-title { background-color: ' . $posts['accent_color'] . '; } #searchford_box' . $post_id . ' .searchford-content .searchford-list li > a:hover{ border-left-color: ' . $posts['accent_color'] . ';}';
                $css .= $posts['width'] == '' ? '' : '#searchford_box' . $post_id . ' { width: ' . $posts['width'] . 'px; }';
                
                // grab old css
                $old_css = get_post_meta( $post_id, '_searchford_css', true);
                
                update_post_meta( $post_id, '_searchford_css', $css );

                if( $old_css != $css ) {
                        searchford_update_static_css();
                }
        }
}

if( !function_exists('searchford_update_static_css') ) {
        function searchford_update_static_css() {
                
                global $wpdb;
                
                $searchford_option = get_option( SEARCHFORD_OPTIONS );
                
                if( $searchford_option ) {
                
                        $r = $wpdb->get_col( $wpdb->prepare( "
                                SELECT pm.meta_value FROM {$wpdb->postmeta} pm
                                LEFT JOIN {$wpdb->posts} p ON p.ID = pm.post_id
                                WHERE pm.meta_key = '%s' 
                                AND p.post_status = '%s' 
                                AND p.post_type = '%s'
                        ", '_searchford_css', 'publish', 'searchford' ) );
        
                        $css = implode('', $r);
                        $css .= $searchford_option['custom_css'];
                        
                        $blog_id = '';
                        if( is_multisite() ) {
                                $blog_id = get_current_blog_id();
                        }
                        
                        $filename = SEARCHFORD_PATH . 'public/css/custom' . $blog_id . '.css';
                        
                        if( file_exists( $filename ) ) {
                                file_put_contents($filename, $css, LOCK_EX);
                        } else {
                                $file = fopen($filename, "w");
                                
                                if( $file == false ) {
                                        die("unable to create file");
                                }
                                
                                fwrite($file, $css);
                                fclose($file);
                        }
                }
        }
}