;
(function ($, window) {
    

    var ExportForm = function ($form) {

        this.$form = $form;
        this.xhr = false;

        this.$form.find('.xa-exporter-progress').val(0);

        this.processStep = this.processStep.bind(this);

        $form.on('click', {ExportForm: this}, this.onSubmit);
    };

    ExportForm.prototype.onSubmit = function (event) {

        event.preventDefault();
        event.data.ExportForm.$form.addClass('duplicator-exporter__exporting');
        event.data.ExportForm.$form.find('.xa-exporter-progress').val(5);
        event.data.ExportForm.$form.find('.xa-export-progress-message > h4').html('Started Compressing...');
        event.data.ExportForm.$form.find('.duplicator-exporter-button').prop('disabled', true);
        event.data.ExportForm.processStep(1, $(this).serialize(), '');
    };


    // process the current export step.

    ExportForm.prototype.processStep = function (step, data, columns) {
        var $this = this;
        //var find_replace_pattern = $("input[name='options[replace]']").map(function(){return $(this).val();}).get();
        
        $.ajax({
            type: 'POST',
            url: ajaxurl,
            data: {
                form: data,
                action: 'xa_do_ajax_wp_export',
                step: step,
                //find_replace_values:find_replace_pattern,
                security: xa_export_params.export_nonce
            },
            dataType: 'json',
            success: function (response) {
                if(response.data.export_progress_message){
                        $this.$form.find('.xa-export-progress-message > h4').html(response.data.export_progress_message);
                    }
                if (response.success) {
                    if ('done' === response.data.step) {

                        $this.$form.find('.xa-exporter-progress').val(response.data.percentage);
                        window.location = response.data.url;
                        setTimeout(function () {
                            $this.$form.removeClass('duplicator-exporter__exporting');
                            $this.$form.find('.duplicator-exporter-button').prop('disabled', false);
                        }, 2000);
                    } else {
                        $this.$form.find('.xa-exporter-progress').val(response.data.percentage);
                        //If the export is not complete, we call the processStep() function from within itself
                        $this.processStep(parseInt(response.data.step, 10), data, response.data.columns);
                    }
                }


            }
        }).fail(function (response) {
            window.console.log(response);
        });
    };

    $.fn.xa_post_export_form = function () {

        new ExportForm(this);
        return this;
    };

    $('.duplicator-exporter').xa_post_export_form();











 var ImportForm = function ($form) {

        this.$form = $form;
        this.xhr = false;
        this.$form.find('.xa-importer-progress').val(0);
        this.processStep = this.processStep.bind(this);
        $form.find('.duplicator-importer-button').on('click', {ImportForm: this}, this.onSubmit);
    };

    ImportForm.prototype.onSubmit = function (event) {

        event.preventDefault();
        event.data.ImportForm.$form.addClass('duplicator-importer__importing');
        event.data.ImportForm.$form.find('.xa-importer-progress').val(5);
        event.data.ImportForm.$form.find('.xa-importer-failed').hide();
        event.data.ImportForm.$form.find('.xa-import-progress-message').show();
        event.data.ImportForm.$form.find('.xa-import-progress-message > h4').html('Processing...');
        event.data.ImportForm.$form.find('.duplicator-importer-button').prop('disabled', true);
        event.data.ImportForm.$form.find('.form-table').hide();
        event.data.ImportForm.processStep(1, $(this).serialize(), '');
        
    };


    // process the current export step.

    ImportForm.prototype.processStep = function (step, data, columns) {
        var $this = this;
        //var find_replace_pattern = $("input[name='options[replace]']").map(function(){return $(this).val();}).get();
        
        
    // You should sterilise the file names
    
    var datas = new FormData();
  	datas.append("action", "xa_do_ajax_wp_import");
        datas.append("security", xa_import_params.import_nonce);
        datas.append("step", step);
        var file = jQuery(document).find('input[type="file"]');
        var individual_file = file[0].files[0];
        datas.append("migration_file", individual_file);


        
        $.ajax({
            type: 'POST',
            url: ajaxurl,
            cache:false,
            processData: false, // Don't process the files
            contentType: false, 
            data: datas,
            
            success: function (response) {
                
                if (response.success) {
                    
                    if(response.data.message){
                        $this.$form.removeClass('duplicator-importer__importing');
                        $this.$form.find('.duplicator-importer-button').prop('disabled', false);
                        $this.$form.find('.xa-importer-failed').show();
                        $this.$form.find('.xa-importer-failed > p').html(response.data.message);
                        $this.$form.find('.xa-import-progress-message').hide();
                        $this.$form.find('.form-table').show();
                        return;
                    }
                    if(response.data.import_progress_message){
                        $this.$form.find('.xa-import-progress-message').show();
                        $this.$form.find('.xa-import-progress-message > h4').html(response.data.import_progress_message);
                        $this.$form.find('.xa-importer-failed').hide();
                    }
                    if ('done' === response.data.step) {

                        $this.$form.find('.xa-importer-progress').val(response.data.percentage);
                        window.location = response.data.url;
                        setTimeout(function () {
                            $this.$form.removeClass('duplicator-importer__importing');
                            $this.$form.find('.duplicator-importer-button').prop('disabled', false);
                        }, 2000);
                    } else {
                        $this.$form.find('.xa-importer-progress').val(response.data.percentage);
                        //If the export is not complete, we call the processStep() function from within itself
                        $this.processStep(parseInt(response.data.step, 10), data, response.data.columns);
                    }
                }


            }
        }).fail(function (response) {
            window.console.log(response);
        });
    };

    $.fn.xa_post_import_form = function () {

        new ImportForm(this);
        return this;
    };

    

















})(jQuery, window);


jQuery(document).ready(function ($) {
    $('.duplicator-importer-button').on('click', $('.duplicator-importer').xa_post_import_form());
    
    'use strict';
    $('#add-new-find-replace-button').showhide_find_replace();
    $('#replace-query-section > li:first ').findreplace_query();
                $('#replace-query-section > li:first ').find('p:first').on('click', function () {
                $(this).parent().toggleClass('expanded');
            });
});
;
(function ($) {

    $.fn.showhide_find_replace = function () {
        $(this).click(function (e) {
            e.preventDefault();

            var row = $('#replace-query-section > li:first').clone();

            // Reset input values
            row.find('input').val('');

            // Reset ai1wm-query-find-text
            row.find('.search-text').html('&lt;text&gt;');

            // Reset ai1wm-query-replace-text
            row.find('.replace-text').html('&lt;another-text&gt;');

            $('#replace-query-section > li').removeClass('expanded');

            $(row).addClass('expanded');

            // Add new replace fields
            $('#replace-query-section').append(row);
            $(row).findreplace_query();
            $(row).find('p:first').on('click', function () {
                $(this).parent().toggleClass('expanded');
            });
            
            
            
        });

        return this;
    };
})(jQuery);

;
(function ($) {

    $.fn.findreplace_query = function () {
        var findInput = $(this).find('input.xa-find-input'),
                replaceInput = $(this).find('input.xa-replace-input'),
                findText = $(this).find('small.search-text'),
                replaceText = $(this).find('small.replace-text');

        findInput.on('change paste input keypress keydown keyup', function () {
            var _inputValue = $(this).val().length > 0 ? $(this).val() : '<text>';
            findText.text(_inputValue);
        });

        replaceInput.on('change paste input keypress keydown keyup', function () {
            var _inputValue = $(this).val().length > 0 ? $(this).val() : '<another-text>';
            replaceText.text(_inputValue);
        });
        return this;
    };
})(jQuery);