<?php
/**
 * Xadapter Helper Functions
 *

 * @author      Mujeeb
 * @category 	Core
 * @package 	Exporter/Functions
 * @version     1.0.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Clean variables using sanitize_text_field. Arrays are cleaned recursively.
 * Non-scalar values are ignored.
 * @param string|array $var
 * @return string|array
 */
function xa_clean( $var ) {
	if ( is_array( $var ) ) {
		return array_map( 'xa_clean', $var );
	} else {
		return is_scalar( $var ) ? sanitize_text_field( $var ) : $var;
	}
}

/**
 * Wrapper for set_time_limit to see if it is enabled.
 * @since 2.6.0
 *
 * @param int $limit
 */
function xa_set_time_limit( $limit = 0 ) {
	if ( function_exists( 'set_time_limit' ) && false === strpos( ini_get( 'disable_functions' ), 'set_time_limit' ) && ! ini_get( 'safe_mode' ) ) {
		@set_time_limit( $limit );
	}
}