<?php
/**
 * Handles Batch CSV export.
 *
 * Based on https://pippinsplugins.com/batch-processing-for-big-data/
 * 
 */


if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'XA_Migration_Exporter', false ) ) {
	include_once( XA_MIGRATION_MAIN_PATH . '/exporter/abstract-migration-exporter.php' );
        include_once( XA_MIGRATION_MAIN_PATH . '/common/helper-functions.php' );
}

abstract class XA_Migration_Batch_Exporter extends XA_Migration_Exporter {


	protected $page = 1;
        public $find_replace;

	public function __construct() {
		
	}

        public function get_page() {
		return $this->page;
	}

	public function set_page( $page ) {
		$this->page = absint( $page );
	}


        /*
	public function get_total_exported_count() {
		return ( $this->get_page() * $this->exported_row_count);
	}
         * 
         */

        public function get_progress_message(){
            $current_step = $this->get_page();
                switch ($current_step) {
                    case 1:
                        return __('Completed compressing plugins', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 20% ';
                    case 2:
                        return __('Completed compressing themes', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 40% ';
                    case 3:
                        return __('Completed compressing uploads', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 60% ';
                    case 4:
                        return __('Completed processing database', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 80% ';
                    case 5:
                        return __('Completed compressing', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 100% ';
                    default:
                        break;
                }
        }
        

        public function get_percent_complete() {
        $current_step = $this->get_page();
                switch ($current_step) {
                    case 1:
                        return 20;
                    case 2:
                        return 40;
                    case 3:
                        return 60;
                    case 4:
                        return 80;
                    case 5:
                        return 100;
                    default:
                        break;
                }
        }
        
        
        
        
        
        
         
}
