<?php

/**
 * Handles Batch import.
 *
 * 
 */
if (!defined('ABSPATH')) {
    exit;
}

if (!class_exists('XA_Migration_Importer', false)) {
    include_once( XA_MIGRATION_MAIN_PATH . '/importer/abstract-migration-importer.php' );
    include_once( XA_MIGRATION_MAIN_PATH . '/common/helper-functions.php' );
}

abstract class XA_Migration_Batch_Importer extends XA_Migration_Importer {

    protected $page = 1;
    public $find_replace;

    public function __construct() {
        
    }

    public function get_page() {
        return $this->page;
    }

    public function set_page($page) {
        $this->page = absint($page);
    }

    abstract protected function process_import();

    /*
    public function get_total_imported_count() {
 
        return ( $this->get_page() * $this->imported_row_count);
    }
     * 
     */
    
    public function get_progress_message(){
                $current_step = $this->get_page();
                switch ($current_step) {
                    case 1:
                        return __('Completed uploading the backup file', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 20% ';
                    case 2:
                        return __('Completed extracting themes', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 40% ';
                    case 3:
                        return __('Completed extracting uploads', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 60% ';
                    case 4:
                        return __('Completed processing plugins', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 80% ';
                    case 5:
                        return __('Completed importing', Duplicator_Migrate_Base::TEXT_DOMAIN). ' - overall 100% ';
                    default:
                        break;
                }
        }

    public function get_percent_complete() {
        $current_step = $this->get_page();
        switch ($current_step) {
            case 1:
                return 20;
            case 2:
                return 40;
            case 3:
                return 60;
            case 4:
                return 80;
            case 5:
                return 100;
            default:
                break;
        }
    }

}
