<?php
$bytes = apply_filters('migration_upload_size_limit', wp_max_upload_size());
$size = size_format($bytes);
?>
<div class="wrap duplicator">

    <div class="duplicator-importer-wrapper">

        <?php if (!empty($upload_dir['error'])) : ?>
            <div class="error"><p><?php _e('Before you can upload your import file, you will need to fix the following error:', Duplicator_Migrate_Base::TEXT_DOMAIN); ?></p>
                <p><strong><?php echo $upload_dir['error']; ?></strong></p></div>
        <?php else : ?>
            <form enctype="multipart/form-data" id="import-upload-form" class="duplicator-importer" >
                <header>
                    <span class="spinner is-active"></span>
                    <h2><?php esc_html_e('You can import your backup file here.', Duplicator_Migrate_Base::TEXT_DOMAIN); ?></h2>
                    <p><i><b><?php _e('The import process will overwrite your database, media, plugins, and themes. 
                        Please ensure that you have a backup of your data before proceeding.', Duplicator_Migrate_Base::TEXT_DOMAIN); ?></i></b></p>

                </header>
                <table class="form-table">
                    <tbody>
                        <tr>
                            <th style="width: 220px; padding-left: 22px;">
                                <label for="upload"><?php _e('Select a file from your computer', Duplicator_Migrate_Base::TEXT_DOMAIN); ?></label>
                            </th>
                            <td>
                                <input type="file" id="migration_file" name="migration_file" size="25"/>
                                <!--<input type="hidden" name="action" value="save" />-->
                                <input type="hidden" name="max_file_size" value="<?php echo $bytes; ?>"/>
                                <small><?php printf(__('Maximum size: %s'), $size); ?></small>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <div class="xa-import-progress-message" style="display:none"><h4></h4></div><br/>
                <progress class="xa-importer-progress" max="100" value="0"></progress>
                <div class="xa-importer-failed" style="display:none"><p></p></div>
                <div class="xa-actions">
                    <!--<input type="submit" class="button button-primary" value="<?php _e('Start Import', Duplicator_Migrate_Base::TEXT_DOMAIN); ?>" />-->
                    <input class="duplicator-importer-button button button-primary" type="button" value="<?php _e('Start Import', Duplicator_Migrate_Base::TEXT_DOMAIN); ?>">
                </div>
            </form>
        <?php endif; ?>
    </div>
</div>